import { l as logger, s as set } from "./index.ea33d1d0.js";
import "@builder.io/qwik";
import "@builder.io/qwik/jsx-runtime";
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x["default"] : x;
}
function getAugmentedNamespace(n) {
  var f = n.default;
  if (typeof f == "function") {
    var a = function() {
      return f.apply(this, arguments);
    };
    a.prototype = f.prototype;
  } else
    a = {};
  Object.defineProperty(a, "__esModule", { value: true });
  Object.keys(n).forEach(function(k) {
    var d = Object.getOwnPropertyDescriptor(n, k);
    Object.defineProperty(a, k, d.get ? d : {
      enumerable: true,
      get: function() {
        return n[k];
      }
    });
  });
  return a;
}
var jsInterpreter = { exports: {} };
const __viteBrowserExternal_vm = new Proxy({}, {
  get(_, key) {
    throw new Error(`Module "vm" has been externalized for browser compatibility. Cannot access "vm.${key}" in client code.`);
  }
});
const __viteBrowserExternal_vm$1 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: __viteBrowserExternal_vm
}, Symbol.toStringTag, { value: "Module" }));
const require$$0 = /* @__PURE__ */ getAugmentedNamespace(__viteBrowserExternal_vm$1);
(function(module, exports) {
  (function webpackUniversalModuleDefinition(root, factory) {
    module.exports = factory();
  })(commonjsGlobal, () => {
    return (() => {
      var __webpack_modules__ = {
        "./original-repo/interpreter.js": function(module2, __unused_webpack_exports, __webpack_require__2) {
          /**
           * @license
           * Copyright 2013 Google LLC
           * SPDX-License-Identifier: Apache-2.0
           */
          var Interpreter2 = function(code, opt_initFunc) {
            if (typeof code === "string") {
              code = this.parse_(code, "code");
            }
            var nodeConstructor = code.constructor;
            this.newNode = function() {
              return new nodeConstructor({ "options": {} });
            };
            var ast = this.newNode();
            for (var prop in code) {
              ast[prop] = prop === "body" ? code[prop].slice() : code[prop];
            }
            this.ast = ast;
            this.initFunc_ = opt_initFunc;
            this.paused_ = false;
            this.polyfills_ = [];
            this.functionCounter_ = 0;
            this.stepFunctions_ = /* @__PURE__ */ Object.create(null);
            var stepMatch = /^step([A-Z]\w*)$/;
            var m;
            for (var methodName in this) {
              if (typeof this[methodName] === "function" && (m = methodName.match(stepMatch))) {
                this.stepFunctions_[m[1]] = this[methodName].bind(this);
              }
            }
            this.globalScope = this.createScope(this.ast, null);
            this.globalObject = this.globalScope.object;
            this.ast = this.parse_(this.polyfills_.join("\n"), "polyfills");
            this.polyfills_ = void 0;
            Interpreter2.stripLocations_(this.ast, void 0, void 0);
            var state = new Interpreter2.State(this.ast, this.globalScope);
            state.done = false;
            this.stateStack = [state];
            this.run();
            this.value = void 0;
            this.ast = ast;
            state = new Interpreter2.State(this.ast, this.globalScope);
            state.done = false;
            this.stateStack.length = 0;
            this.stateStack[0] = state;
          };
          Interpreter2.Completion = {
            NORMAL: 0,
            BREAK: 1,
            CONTINUE: 2,
            RETURN: 3,
            THROW: 4
          };
          Interpreter2.PARSE_OPTIONS = {
            "locations": true,
            "ecmaVersion": 5
          };
          Interpreter2.READONLY_DESCRIPTOR = {
            configurable: true,
            enumerable: true,
            writable: false
          };
          Interpreter2.NONENUMERABLE_DESCRIPTOR = {
            configurable: true,
            enumerable: false,
            writable: true
          };
          Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR = {
            configurable: true,
            enumerable: false,
            writable: false
          };
          Interpreter2.NONCONFIGURABLE_READONLY_NONENUMERABLE_DESCRIPTOR = {
            configurable: false,
            enumerable: false,
            writable: false
          };
          Interpreter2.VARIABLE_DESCRIPTOR = {
            configurable: false,
            enumerable: true,
            writable: true
          };
          Interpreter2.STEP_ERROR = { "STEP_ERROR": true };
          Interpreter2.SCOPE_REFERENCE = { "SCOPE_REFERENCE": true };
          Interpreter2.VALUE_IN_DESCRIPTOR = { "VALUE_IN_DESCRIPTOR": true };
          Interpreter2.REGEXP_TIMEOUT = { "REGEXP_TIMEOUT": true };
          Interpreter2.toStringCycles_ = [];
          Interpreter2.vm = null;
          Interpreter2.currentInterpreter_ = null;
          Interpreter2.nativeGlobal = typeof globalThis === "undefined" ? this : globalThis;
          Interpreter2.WORKER_CODE = [
            "onmessage = function(e) {",
            "var result;",
            "var data = e.data;",
            "switch (data[0]) {",
            "case 'split':",
            "result = data[1].split(data[2], data[3]);",
            "break;",
            "case 'match':",
            "result = data[1].match(data[2]);",
            "break;",
            "case 'search':",
            "result = data[1].search(data[2]);",
            "break;",
            "case 'replace':",
            "result = data[1].replace(data[2], data[3]);",
            "break;",
            "case 'exec':",
            "var regexp = data[1];",
            "regexp.lastIndex = data[2];",
            "result = [regexp.exec(data[3]), data[1].lastIndex];",
            "break;",
            "default:",
            "throw Error('Unknown RegExp operation: ' + data[0]);",
            "}",
            "postMessage(result);",
            "close();",
            "};"
          ];
          Interpreter2.legalArrayLength = function(x) {
            var n = x >>> 0;
            return n === Number(x) ? n : NaN;
          };
          Interpreter2.legalArrayIndex = function(x) {
            var n = x >>> 0;
            return String(n) === String(x) && n !== 4294967295 ? n : NaN;
          };
          Interpreter2.stripLocations_ = function(node, start, end) {
            if (start) {
              node["start"] = start;
            } else {
              delete node["start"];
            }
            if (end) {
              node["end"] = end;
            } else {
              delete node["end"];
            }
            for (var name in node) {
              if (name !== "loc" && node.hasOwnProperty(name)) {
                var prop = node[name];
                if (prop && typeof prop === "object") {
                  Interpreter2.stripLocations_(prop, start, end);
                }
              }
            }
          };
          Interpreter2.prototype["REGEXP_MODE"] = 2;
          Interpreter2.prototype["REGEXP_THREAD_TIMEOUT"] = 1e3;
          Interpreter2.prototype["POLYFILL_TIMEOUT"] = 1e3;
          Interpreter2.prototype.getterStep_ = false;
          Interpreter2.prototype.setterStep_ = false;
          Interpreter2.prototype.appendCodeNumber_ = 0;
          Interpreter2.prototype.parse_ = function(code, sourceFile) {
            var options = {};
            for (var name in Interpreter2.PARSE_OPTIONS) {
              options[name] = Interpreter2.PARSE_OPTIONS[name];
            }
            options["sourceFile"] = sourceFile;
            return Interpreter2.nativeGlobal["acorn"].parse(code, options);
          };
          Interpreter2.prototype.appendCode = function(code) {
            var state = this.stateStack[0];
            if (!state || state.node["type"] !== "Program") {
              throw Error("Expecting original AST to start with a Program node");
            }
            if (typeof code === "string") {
              code = this.parse_(code, "appendCode" + this.appendCodeNumber_++);
            }
            if (!code || code["type"] !== "Program") {
              throw Error("Expecting new AST to start with a Program node");
            }
            this.populateScope_(code, state.scope);
            Array.prototype.push.apply(state.node["body"], code["body"]);
            state.node["body"].variableCache_ = null;
            state.done = false;
          };
          Interpreter2.prototype.step = function() {
            var stack = this.stateStack;
            do {
              var state = stack[stack.length - 1];
              if (!state) {
                return false;
              }
              var node = state.node, type = node["type"];
              if (type === "Program" && state.done) {
                return false;
              } else if (this.paused_) {
                return true;
              }
              var oldInterpreterValue = Interpreter2.currentInterpreter_;
              Interpreter2.currentInterpreter_ = this;
              try {
                var nextState = this.stepFunctions_[type](stack, state, node);
              } catch (e) {
                if (e !== Interpreter2.STEP_ERROR) {
                  throw e;
                }
              } finally {
                Interpreter2.currentInterpreter_ = oldInterpreterValue;
              }
              if (nextState) {
                stack.push(nextState);
              }
              if (this.getterStep_) {
                throw Error("Getter not supported in this context");
              }
              if (this.setterStep_) {
                throw Error("Setter not supported in this context");
              }
              if (!endTime && !node["end"]) {
                var endTime = Date.now() + this["POLYFILL_TIMEOUT"];
              }
            } while (!node["end"] && endTime > Date.now());
            return true;
          };
          Interpreter2.prototype.run = function() {
            while (!this.paused_ && this.step()) {
            }
            return this.paused_;
          };
          Interpreter2.prototype.initGlobal = function(globalObject) {
            this.setProperty(
              globalObject,
              "NaN",
              NaN,
              Interpreter2.NONCONFIGURABLE_READONLY_NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              globalObject,
              "Infinity",
              Infinity,
              Interpreter2.NONCONFIGURABLE_READONLY_NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              globalObject,
              "undefined",
              void 0,
              Interpreter2.NONCONFIGURABLE_READONLY_NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              globalObject,
              "window",
              globalObject,
              Interpreter2.READONLY_DESCRIPTOR
            );
            this.setProperty(
              globalObject,
              "this",
              globalObject,
              Interpreter2.NONCONFIGURABLE_READONLY_NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(globalObject, "self", globalObject);
            this.OBJECT_PROTO = new Interpreter2.Object(null);
            this.FUNCTION_PROTO = new Interpreter2.Object(this.OBJECT_PROTO);
            this.initFunction(globalObject);
            this.initObject(globalObject);
            globalObject.proto = this.OBJECT_PROTO;
            this.setProperty(
              globalObject,
              "constructor",
              this.OBJECT,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.initArray(globalObject);
            this.initString(globalObject);
            this.initBoolean(globalObject);
            this.initNumber(globalObject);
            this.initDate(globalObject);
            this.initRegExp(globalObject);
            this.initError(globalObject);
            this.initMath(globalObject);
            this.initJSON(globalObject);
            var thisInterpreter = this;
            var func = this.createNativeFunction(
              function(_x) {
                throw EvalError("Can't happen");
              },
              false
            );
            func.eval = true;
            this.setProperty(
              globalObject,
              "eval",
              func,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              globalObject,
              "parseInt",
              this.createNativeFunction(parseInt, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              globalObject,
              "parseFloat",
              this.createNativeFunction(parseFloat, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              globalObject,
              "isNaN",
              this.createNativeFunction(isNaN, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              globalObject,
              "isFinite",
              this.createNativeFunction(isFinite, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            var strFunctions = [
              [escape, "escape"],
              [unescape, "unescape"],
              [decodeURI, "decodeURI"],
              [decodeURIComponent, "decodeURIComponent"],
              [encodeURI, "encodeURI"],
              [encodeURIComponent, "encodeURIComponent"]
            ];
            for (var i = 0; i < strFunctions.length; i++) {
              var wrapper = function(nativeFunc) {
                return function(str) {
                  try {
                    return nativeFunc(str);
                  } catch (e) {
                    thisInterpreter.throwException(thisInterpreter.URI_ERROR, e.message);
                  }
                };
              }(strFunctions[i][0]);
              this.setProperty(
                globalObject,
                strFunctions[i][1],
                this.createNativeFunction(wrapper, false),
                Interpreter2.NONENUMERABLE_DESCRIPTOR
              );
            }
            this["OBJECT"] = this.OBJECT;
            this["OBJECT_PROTO"] = this.OBJECT_PROTO;
            this["FUNCTION"] = this.FUNCTION;
            this["FUNCTION_PROTO"] = this.FUNCTION_PROTO;
            this["ARRAY"] = this.ARRAY;
            this["ARRAY_PROTO"] = this.ARRAY_PROTO;
            this["REGEXP"] = this.REGEXP;
            this["REGEXP_PROTO"] = this.REGEXP_PROTO;
            this["DATE"] = this.DATE;
            this["DATE_PROTO"] = this.DATE_PROTO;
            if (this.initFunc_) {
              this.initFunc_(this, globalObject);
            }
          };
          Interpreter2.prototype.functionCodeNumber_ = 0;
          Interpreter2.prototype.initFunction = function(globalObject) {
            var thisInterpreter = this;
            var wrapper;
            var identifierRegexp = /^[A-Za-z_$][\w$]*$/;
            wrapper = function Function2(var_args) {
              if (arguments.length) {
                var code = String(arguments[arguments.length - 1]);
              } else {
                var code = "";
              }
              var argsStr = Array.prototype.slice.call(arguments, 0, -1).join(",").trim();
              if (argsStr) {
                var args = argsStr.split(/\s*,\s*/);
                for (var i = 0; i < args.length; i++) {
                  var name = args[i];
                  if (!identifierRegexp.test(name)) {
                    thisInterpreter.throwException(
                      thisInterpreter.SYNTAX_ERROR,
                      "Invalid function argument: " + name
                    );
                  }
                }
                argsStr = args.join(", ");
              }
              try {
                var ast = thisInterpreter.parse_(
                  "(function(" + argsStr + ") {" + code + "})",
                  "function" + thisInterpreter.functionCodeNumber_++
                );
              } catch (e) {
                thisInterpreter.throwException(
                  thisInterpreter.SYNTAX_ERROR,
                  "Invalid code: " + e.message
                );
              }
              if (ast["body"].length !== 1) {
                thisInterpreter.throwException(
                  thisInterpreter.SYNTAX_ERROR,
                  "Invalid code in function body."
                );
              }
              var node = ast["body"][0]["expression"];
              return thisInterpreter.createFunction(node, thisInterpreter.globalScope, "anonymous");
            };
            this.FUNCTION = this.createNativeFunction(wrapper, true);
            this.setProperty(
              globalObject,
              "Function",
              this.FUNCTION,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.FUNCTION,
              "prototype",
              this.FUNCTION_PROTO,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.FUNCTION_PROTO,
              "constructor",
              this.FUNCTION,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.FUNCTION_PROTO.nativeFunc = function() {
            };
            this.FUNCTION_PROTO.nativeFunc.id = this.functionCounter_++;
            this.FUNCTION_PROTO.illegalConstructor = true;
            this.setProperty(
              this.FUNCTION_PROTO,
              "length",
              0,
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
            this.FUNCTION_PROTO.class = "Function";
            wrapper = function apply(thisArg, args) {
              var state = thisInterpreter.stateStack[thisInterpreter.stateStack.length - 1];
              state.func_ = this;
              state.funcThis_ = thisArg;
              state.arguments_ = [];
              if (args !== null && args !== void 0) {
                if (args instanceof Interpreter2.Object) {
                  state.arguments_ = thisInterpreter.arrayPseudoToNative(args);
                } else {
                  thisInterpreter.throwException(
                    thisInterpreter.TYPE_ERROR,
                    "CreateListFromArrayLike called on non-object"
                  );
                }
              }
              state.doneExec_ = false;
            };
            this.setNativeFunctionPrototype(this.FUNCTION, "apply", wrapper);
            wrapper = function call(thisArg) {
              var state = thisInterpreter.stateStack[thisInterpreter.stateStack.length - 1];
              state.func_ = this;
              state.funcThis_ = thisArg;
              state.arguments_ = [];
              for (var i = 1; i < arguments.length; i++) {
                state.arguments_.push(arguments[i]);
              }
              state.doneExec_ = false;
            };
            this.setNativeFunctionPrototype(this.FUNCTION, "call", wrapper);
            this.polyfills_.push(
              "Object.defineProperty(Function.prototype, 'bind',",
              "{configurable: true, writable: true, value:",
              "function bind(oThis) {",
              "if (typeof this !== 'function') {",
              "throw TypeError('What is trying to be bound is not callable');",
              "}",
              "var aArgs   = Array.prototype.slice.call(arguments, 1),",
              "fToBind = this,",
              "fNOP    = function() {},",
              "fBound  = function() {",
              "return fToBind.apply(this instanceof fNOP",
              "? this",
              ": oThis,",
              "aArgs.concat(Array.prototype.slice.call(arguments)));",
              "};",
              "if (this.prototype) {",
              "fNOP.prototype = this.prototype;",
              "}",
              "fBound.prototype = new fNOP();",
              "return fBound;",
              "}",
              "});",
              ""
            );
            wrapper = function toString() {
              return String(this);
            };
            this.setNativeFunctionPrototype(this.FUNCTION, "toString", wrapper);
            this.setProperty(
              this.FUNCTION,
              "toString",
              this.createNativeFunction(wrapper, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            wrapper = function valueOf() {
              return this.valueOf();
            };
            this.setNativeFunctionPrototype(this.FUNCTION, "valueOf", wrapper);
            this.setProperty(
              this.FUNCTION,
              "valueOf",
              this.createNativeFunction(wrapper, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
          };
          Interpreter2.prototype.initObject = function(globalObject) {
            var thisInterpreter = this;
            var wrapper;
            wrapper = function Object2(value) {
              if (value === void 0 || value === null) {
                if (thisInterpreter.calledWithNew()) {
                  return this;
                } else {
                  return thisInterpreter.createObjectProto(thisInterpreter.OBJECT_PROTO);
                }
              }
              if (!(value instanceof Interpreter2.Object)) {
                var box = thisInterpreter.createObjectProto(
                  thisInterpreter.getPrototype(value)
                );
                box.data = value;
                return box;
              }
              return value;
            };
            this.OBJECT = this.createNativeFunction(wrapper, true);
            this.setProperty(
              this.OBJECT,
              "prototype",
              this.OBJECT_PROTO,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.OBJECT_PROTO,
              "constructor",
              this.OBJECT,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              globalObject,
              "Object",
              this.OBJECT,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            var throwIfNullUndefined = function(value) {
              if (value === void 0 || value === null) {
                thisInterpreter.throwException(
                  thisInterpreter.TYPE_ERROR,
                  "Cannot convert '" + value + "' to object"
                );
              }
            };
            wrapper = function getOwnPropertyNames(obj) {
              throwIfNullUndefined(obj);
              var props = obj instanceof Interpreter2.Object ? obj.properties : obj;
              return thisInterpreter.arrayNativeToPseudo(
                Object.getOwnPropertyNames(props)
              );
            };
            this.setProperty(
              this.OBJECT,
              "getOwnPropertyNames",
              this.createNativeFunction(wrapper, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            wrapper = function keys(obj) {
              throwIfNullUndefined(obj);
              if (obj instanceof Interpreter2.Object) {
                obj = obj.properties;
              }
              return thisInterpreter.arrayNativeToPseudo(Object.keys(obj));
            };
            this.setProperty(
              this.OBJECT,
              "keys",
              this.createNativeFunction(wrapper, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            wrapper = function create_(proto) {
              if (proto === null) {
                return thisInterpreter.createObjectProto(null);
              }
              if (!(proto instanceof Interpreter2.Object)) {
                thisInterpreter.throwException(
                  thisInterpreter.TYPE_ERROR,
                  "Object prototype may only be an Object or null"
                );
              }
              return thisInterpreter.createObjectProto(proto);
            };
            this.setProperty(
              this.OBJECT,
              "create",
              this.createNativeFunction(wrapper, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.polyfills_.push(
              "(function() {",
              "var create_ = Object.create;",
              "Object.create = function create(proto, props) {",
              "var obj = create_(proto);",
              "props && Object.defineProperties(obj, props);",
              "return obj;",
              "};",
              "})();",
              ""
            );
            wrapper = function defineProperty(obj, prop, descriptor) {
              prop = String(prop);
              if (!(obj instanceof Interpreter2.Object)) {
                thisInterpreter.throwException(
                  thisInterpreter.TYPE_ERROR,
                  "Object.defineProperty called on non-object"
                );
              }
              if (!(descriptor instanceof Interpreter2.Object)) {
                thisInterpreter.throwException(
                  thisInterpreter.TYPE_ERROR,
                  "Property description must be an object"
                );
              }
              if (!obj.properties[prop] && obj.preventExtensions) {
                thisInterpreter.throwException(
                  thisInterpreter.TYPE_ERROR,
                  "Can't define property '" + prop + "', object is not extensible"
                );
              }
              thisInterpreter.setProperty(
                obj,
                prop,
                Interpreter2.VALUE_IN_DESCRIPTOR,
                descriptor.properties
              );
              return obj;
            };
            this.setProperty(
              this.OBJECT,
              "defineProperty",
              this.createNativeFunction(wrapper, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.polyfills_.push(
              "(function() {",
              "var defineProperty_ = Object.defineProperty;",
              "Object.defineProperty = function defineProperty(obj, prop, d1) {",
              "var d2 = {};",
              "if ('configurable' in d1) d2.configurable = d1.configurable;",
              "if ('enumerable' in d1) d2.enumerable = d1.enumerable;",
              "if ('writable' in d1) d2.writable = d1.writable;",
              "if ('value' in d1) d2.value = d1.value;",
              "if ('get' in d1) d2.get = d1.get;",
              "if ('set' in d1) d2.set = d1.set;",
              "return defineProperty_(obj, prop, d2);",
              "};",
              "})();",
              "Object.defineProperty(Object, 'defineProperties',",
              "{configurable: true, writable: true, value:",
              "function defineProperties(obj, props) {",
              "var keys = Object.keys(props);",
              "for (var i = 0; i < keys.length; i++) {",
              "Object.defineProperty(obj, keys[i], props[keys[i]]);",
              "}",
              "return obj;",
              "}",
              "});",
              ""
            );
            wrapper = function getOwnPropertyDescriptor(obj, prop) {
              if (!(obj instanceof Interpreter2.Object)) {
                thisInterpreter.throwException(
                  thisInterpreter.TYPE_ERROR,
                  "Object.getOwnPropertyDescriptor called on non-object"
                );
              }
              prop = String(prop);
              if (!(prop in obj.properties)) {
                return void 0;
              }
              var descriptor = Object.getOwnPropertyDescriptor(obj.properties, prop);
              var getter = obj.getter[prop];
              var setter = obj.setter[prop];
              var pseudoDescriptor = thisInterpreter.createObjectProto(thisInterpreter.OBJECT_PROTO);
              if (getter || setter) {
                thisInterpreter.setProperty(pseudoDescriptor, "get", getter);
                thisInterpreter.setProperty(pseudoDescriptor, "set", setter);
              } else {
                thisInterpreter.setProperty(
                  pseudoDescriptor,
                  "value",
                  descriptor.value
                );
                thisInterpreter.setProperty(
                  pseudoDescriptor,
                  "writable",
                  descriptor.writable
                );
              }
              thisInterpreter.setProperty(
                pseudoDescriptor,
                "configurable",
                descriptor.configurable
              );
              thisInterpreter.setProperty(
                pseudoDescriptor,
                "enumerable",
                descriptor.enumerable
              );
              return pseudoDescriptor;
            };
            this.setProperty(
              this.OBJECT,
              "getOwnPropertyDescriptor",
              this.createNativeFunction(wrapper, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            wrapper = function getPrototypeOf(obj) {
              throwIfNullUndefined(obj);
              return thisInterpreter.getPrototype(obj);
            };
            this.setProperty(
              this.OBJECT,
              "getPrototypeOf",
              this.createNativeFunction(wrapper, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            wrapper = function isExtensible(obj) {
              return Boolean(obj) && !obj.preventExtensions;
            };
            this.setProperty(
              this.OBJECT,
              "isExtensible",
              this.createNativeFunction(wrapper, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            wrapper = function preventExtensions(obj) {
              if (obj instanceof Interpreter2.Object) {
                obj.preventExtensions = true;
              }
              return obj;
            };
            this.setProperty(
              this.OBJECT,
              "preventExtensions",
              this.createNativeFunction(wrapper, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setNativeFunctionPrototype(
              this.OBJECT,
              "toString",
              Interpreter2.Object.prototype.toString
            );
            this.setNativeFunctionPrototype(
              this.OBJECT,
              "toLocaleString",
              Interpreter2.Object.prototype.toString
            );
            this.setNativeFunctionPrototype(
              this.OBJECT,
              "valueOf",
              Interpreter2.Object.prototype.valueOf
            );
            wrapper = function hasOwnProperty(prop) {
              throwIfNullUndefined(this);
              if (this instanceof Interpreter2.Object) {
                return String(prop) in this.properties;
              }
              return this.hasOwnProperty(prop);
            };
            this.setNativeFunctionPrototype(this.OBJECT, "hasOwnProperty", wrapper);
            wrapper = function propertyIsEnumerable(prop) {
              throwIfNullUndefined(this);
              if (this instanceof Interpreter2.Object) {
                return Object.prototype.propertyIsEnumerable.call(this.properties, prop);
              }
              return this.propertyIsEnumerable(prop);
            };
            this.setNativeFunctionPrototype(this.OBJECT, "propertyIsEnumerable", wrapper);
            wrapper = function isPrototypeOf(obj) {
              while (true) {
                obj = thisInterpreter.getPrototype(obj);
                if (!obj) {
                  return false;
                }
                if (obj === this) {
                  return true;
                }
              }
            };
            this.setNativeFunctionPrototype(this.OBJECT, "isPrototypeOf", wrapper);
          };
          Interpreter2.prototype.initArray = function(globalObject) {
            var thisInterpreter = this;
            var wrapper;
            wrapper = function Array2(var_args) {
              if (thisInterpreter.calledWithNew()) {
                var newArray = this;
              } else {
                var newArray = thisInterpreter.createArray();
              }
              var first = arguments[0];
              if (arguments.length === 1 && typeof first === "number") {
                if (isNaN(Interpreter2.legalArrayLength(first))) {
                  thisInterpreter.throwException(
                    thisInterpreter.RANGE_ERROR,
                    "Invalid array length"
                  );
                }
                newArray.properties.length = first;
              } else {
                for (var i = 0; i < arguments.length; i++) {
                  newArray.properties[i] = arguments[i];
                }
                newArray.properties.length = i;
              }
              return newArray;
            };
            this.ARRAY = this.createNativeFunction(wrapper, true);
            this.ARRAY_PROTO = this.ARRAY.properties["prototype"];
            this.setProperty(
              globalObject,
              "Array",
              this.ARRAY,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            wrapper = function isArray(obj) {
              return obj && obj.class === "Array";
            };
            this.setProperty(
              this.ARRAY,
              "isArray",
              this.createNativeFunction(wrapper, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.ARRAY_PROTO,
              "length",
              0,
              { configurable: false, enumerable: false, writable: true }
            );
            this.ARRAY_PROTO.class = "Array";
            this.polyfills_.push(
              "Object.defineProperty(Array.prototype, 'pop',",
              "{configurable: true, writable: true, value:",
              "function pop() {",
              "if (!this) throw TypeError();",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "if (!len || len < 0) {",
              "o.length = 0;",
              "return undefined;",
              "}",
              "len--;",
              "var x = o[len];",
              "delete o[len];",
              "o.length = len;",
              "return x;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'push',",
              "{configurable: true, writable: true, value:",
              "function push(var_args) {",
              "if (!this) throw TypeError();",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "for (var i = 0; i < arguments.length; i++) {",
              "o[len] = arguments[i];",
              "len++;",
              "}",
              "o.length = len;",
              "return len;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'shift',",
              "{configurable: true, writable: true, value:",
              "function shift() {",
              "if (!this) throw TypeError();",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "if (!len || len < 0) {",
              "o.length = 0;",
              "return undefined;",
              "}",
              "var value = o[0];",
              "for (var i = 0; i < len - 1; i++) {",
              "if ((i + 1) in o) {",
              "o[i] = o[i + 1];",
              "} else {",
              "delete o[i];",
              "}",
              "}",
              "delete o[i];",
              "o.length = len - 1;",
              "return value;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'unshift',",
              "{configurable: true, writable: true, value:",
              "function unshift(var_args) {",
              "if (!this) throw TypeError();",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "if (!len || len < 0) {",
              "len = 0;",
              "}",
              "for (var i = len - 1; i >= 0; i--) {",
              "if (i in o) {",
              "o[i + arguments.length] = o[i];",
              "} else {",
              "delete o[i + arguments.length];",
              "}",
              "}",
              "for (var i = 0; i < arguments.length; i++) {",
              "o[i] = arguments[i];",
              "}",
              "return (o.length = len + arguments.length);",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'reverse',",
              "{configurable: true, writable: true, value:",
              "function reverse() {",
              "if (!this) throw TypeError();",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "if (!len || len < 2) {",
              "return o;",
              "}",
              "for (var i = 0; i < len / 2 - 0.5; i++) {",
              "var x = o[i];",
              "var hasX = i in o;",
              "if ((len - i - 1) in o) {",
              "o[i] = o[len - i - 1];",
              "} else {",
              "delete o[i];",
              "}",
              "if (hasX) {",
              "o[len - i - 1] = x;",
              "} else {",
              "delete o[len - i - 1];",
              "}",
              "}",
              "return o;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'indexOf',",
              "{configurable: true, writable: true, value:",
              "function indexOf(searchElement, fromIndex) {",
              "if (!this) throw TypeError();",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "var n = fromIndex | 0;",
              "if (!len || n >= len) {",
              "return -1;",
              "}",
              "var i = Math.max(n >= 0 ? n : len - Math.abs(n), 0);",
              "while (i < len) {",
              "if (i in o && o[i] === searchElement) {",
              "return i;",
              "}",
              "i++;",
              "}",
              "return -1;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'lastIndexOf',",
              "{configurable: true, writable: true, value:",
              "function lastIndexOf(searchElement, fromIndex) {",
              "if (!this) throw TypeError();",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "if (!len) {",
              "return -1;",
              "}",
              "var n = len - 1;",
              "if (arguments.length > 1) {",
              "n = fromIndex | 0;",
              "if (n) {",
              "n = (n > 0 || -1) * Math.floor(Math.abs(n));",
              "}",
              "}",
              "var i = n >= 0 ? Math.min(n, len - 1) : len - Math.abs(n);",
              "while (i >= 0) {",
              "if (i in o && o[i] === searchElement) {",
              "return i;",
              "}",
              "i--;",
              "}",
              "return -1;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'slice',",
              "{configurable: true, writable: true, value:",
              "function slice(start, end) {",
              "if (!this) throw TypeError();",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "start |= 0;",
              "start = (start >= 0) ? start : Math.max(0, len + start);",
              "if (typeof end !== 'undefined') {",
              "if (end !== Infinity) {",
              "end |= 0;",
              "}",
              "if (end < 0) {",
              "end = len + end;",
              "} else {",
              "end = Math.min(end, len);",
              "}",
              "} else {",
              "end = len;",
              "}",
              "var size = end - start;",
              "var cloned = new Array(size);",
              "for (var i = 0; i < size; i++) {",
              "if ((start + i) in o) {",
              "cloned[i] = o[start + i];",
              "}",
              "}",
              "return cloned;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'splice',",
              "{configurable: true, writable: true, value:",
              "function splice(start, deleteCount, var_args) {",
              "if (!this) throw TypeError();",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "start |= 0;",
              "if (start < 0) {",
              "start = Math.max(len + start, 0);",
              "} else {",
              "start = Math.min(start, len);",
              "}",
              "if (arguments.length < 1) {",
              "deleteCount = len - start;",
              "} else {",
              "deleteCount |= 0;",
              "deleteCount = Math.max(0, Math.min(deleteCount, len - start));",
              "}",
              "var removed = [];",
              "for (var i = start; i < start + deleteCount; i++) {",
              "if (i in o) {",
              "removed.push(o[i]);",
              "} else {",
              "removed.length++;",
              "}",
              "if ((i + deleteCount) in o) {",
              "o[i] = o[i + deleteCount];",
              "} else {",
              "delete o[i];",
              "}",
              "}",
              "for (var i = start + deleteCount; i < len - deleteCount; i++) {",
              "if ((i + deleteCount) in o) {",
              "o[i] = o[i + deleteCount];",
              "} else {",
              "delete o[i];",
              "}",
              "}",
              "for (var i = len - deleteCount; i < len; i++) {",
              "delete o[i];",
              "}",
              "len -= deleteCount;",
              "var arl = arguments.length - 2;",
              "for (var i = len - 1; i >= start; i--) {",
              "if (i in o) {",
              "o[i + arl] = o[i];",
              "} else {",
              "delete o[i + arl];",
              "}",
              "}",
              "len += arl;",
              "for (var i = 2; i < arguments.length; i++) {",
              "o[start + i - 2] = arguments[i];",
              "}",
              "o.length = len;",
              "return removed;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'concat',",
              "{configurable: true, writable: true, value:",
              "function concat(var_args) {",
              "if (!this) throw TypeError();",
              "var o = Object(this);",
              "var cloned = [];",
              "for (var i = -1; i < arguments.length; i++) {",
              "var value = (i === -1) ? o : arguments[i];",
              "if (Array.isArray(value)) {",
              "for (var j = 0, l = value.length; j < l; j++) {",
              "if (j in value) {",
              "cloned.push(value[j]);",
              "} else {",
              "cloned.length++;",
              "}",
              "}",
              "} else {",
              "cloned.push(value);",
              "}",
              "}",
              "return cloned;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'join',",
              "{configurable: true, writable: true, value:",
              "function join(opt_separator) {",
              "if (!this) throw TypeError();",
              "var o = Object(this);",
              "var sep = typeof opt_separator === 'undefined' ?",
              "',' : ('' + opt_separator);",
              "var str = '';",
              "for (var i = 0; i < o.length; i++) {",
              "if (i && sep) {",
              "str += sep;",
              "}",
              "str += (o[i] === null || o[i] === undefined) ? '' : o[i];",
              "}",
              "return str;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'every',",
              "{configurable: true, writable: true, value:",
              "function every(callbackfn, thisArg) {",
              "if (!this || typeof callbackfn !== 'function') throw TypeError();",
              "var t, k;",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "if (arguments.length > 1) t = thisArg;",
              "k = 0;",
              "while (k < len) {",
              "if (k in o && !callbackfn.call(t, o[k], k, o)) return false;",
              "k++;",
              "}",
              "return true;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'filter',",
              "{configurable: true, writable: true, value:",
              "function filter(fun, var_args) {",
              "if (this === void 0 || this === null || typeof fun !== 'function') throw TypeError();",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "var res = [];",
              "var thisArg = arguments.length >= 2 ? arguments[1] : void 0;",
              "for (var i = 0; i < len; i++) {",
              "if (i in o) {",
              "var val = o[i];",
              "if (fun.call(thisArg, val, i, o)) res.push(val);",
              "}",
              "}",
              "return res;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'forEach',",
              "{configurable: true, writable: true, value:",
              "function forEach(callback, thisArg) {",
              "if (!this || typeof callback !== 'function') throw TypeError();",
              "var t, k;",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "if (arguments.length > 1) t = thisArg;",
              "k = 0;",
              "while (k < len) {",
              "if (k in o) callback.call(t, o[k], k, o);",
              "k++;",
              "}",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'map',",
              "{configurable: true, writable: true, value:",
              "function map(callback, thisArg) {",
              "if (!this || typeof callback !== 'function') throw TypeError();",
              "var t, a, k;",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "if (arguments.length > 1) t = thisArg;",
              "a = new Array(len);",
              "k = 0;",
              "while (k < len) {",
              "if (k in o) a[k] = callback.call(t, o[k], k, o);",
              "k++;",
              "}",
              "return a;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'reduce',",
              "{configurable: true, writable: true, value:",
              "function reduce(callback /*, initialValue*/) {",
              "if (!this || typeof callback !== 'function') throw TypeError();",
              "var o = Object(this), len = o.length >>> 0, k = 0, value;",
              "if (arguments.length === 2) {",
              "value = arguments[1];",
              "} else {",
              "while (k < len && !(k in o)) k++;",
              "if (k >= len) {",
              "throw TypeError('Reduce of empty array with no initial value');",
              "}",
              "value = o[k++];",
              "}",
              "for (; k < len; k++) {",
              "if (k in o) value = callback(value, o[k], k, o);",
              "}",
              "return value;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'reduceRight',",
              "{configurable: true, writable: true, value:",
              "function reduceRight(callback /*, initialValue*/) {",
              "if (null === this || 'undefined' === typeof this || 'function' !== typeof callback) throw TypeError();",
              "var o = Object(this), len = o.length >>> 0, k = len - 1, value;",
              "if (arguments.length >= 2) {",
              "value = arguments[1];",
              "} else {",
              "while (k >= 0 && !(k in o)) k--;",
              "if (k < 0) {",
              "throw TypeError('Reduce of empty array with no initial value');",
              "}",
              "value = o[k--];",
              "}",
              "for (; k >= 0; k--) {",
              "if (k in o) value = callback(value, o[k], k, o);",
              "}",
              "return value;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'some',",
              "{configurable: true, writable: true, value:",
              "function some(fun/*, thisArg*/) {",
              "if (!this || typeof fun !== 'function') throw TypeError();",
              "var o = Object(this);",
              "var len = o.length >>> 0;",
              "var thisArg = arguments.length >= 2 ? arguments[1] : void 0;",
              "for (var i = 0; i < len; i++) {",
              "if (i in o && fun.call(thisArg, o[i], i, o)) {",
              "return true;",
              "}",
              "}",
              "return false;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'sort',",
              "{configurable: true, writable: true, value:",
              "function sort(opt_comp) {",
              "if (!this) throw TypeError();",
              "if (typeof opt_comp !== 'function') {",
              "opt_comp = undefined;",
              "}",
              "for (var i = 0; i < this.length; i++) {",
              "var changes = 0;",
              "for (var j = 0; j < this.length - i - 1; j++) {",
              "if (opt_comp ? (opt_comp(this[j], this[j + 1]) > 0) :",
              "(String(this[j]) > String(this[j + 1]))) {",
              "var swap = this[j];",
              "var hasSwap = j in this;",
              "if ((j + 1) in this) {",
              "this[j] = this[j + 1];",
              "} else {",
              "delete this[j];",
              "}",
              "if (hasSwap) {",
              "this[j + 1] = swap;",
              "} else {",
              "delete this[j + 1];",
              "}",
              "changes++;",
              "}",
              "}",
              "if (!changes) break;",
              "}",
              "return this;",
              "}",
              "});",
              "Object.defineProperty(Array.prototype, 'toLocaleString',",
              "{configurable: true, writable: true, value:",
              "function toLocaleString() {",
              "if (!this) throw TypeError();",
              "var o = Object(this);",
              "var out = [];",
              "for (var i = 0; i < o.length; i++) {",
              "out[i] = (o[i] === null || o[i] === undefined) ? '' : o[i].toLocaleString();",
              "}",
              "return out.join(',');",
              "}",
              "});",
              ""
            );
          };
          Interpreter2.prototype.initString = function(globalObject) {
            var thisInterpreter = this;
            var wrapper;
            wrapper = function String2(value) {
              value = arguments.length ? Interpreter2.nativeGlobal.String(value) : "";
              if (thisInterpreter.calledWithNew()) {
                this.data = value;
                return this;
              } else {
                return value;
              }
            };
            this.STRING = this.createNativeFunction(wrapper, true);
            this.setProperty(
              globalObject,
              "String",
              this.STRING,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.STRING,
              "fromCharCode",
              this.createNativeFunction(String.fromCharCode, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            var functions = [
              "charAt",
              "charCodeAt",
              "concat",
              "indexOf",
              "lastIndexOf",
              "slice",
              "substr",
              "substring",
              "toLocaleLowerCase",
              "toLocaleUpperCase",
              "toLowerCase",
              "toUpperCase",
              "trim"
            ];
            for (var i = 0; i < functions.length; i++) {
              this.setNativeFunctionPrototype(
                this.STRING,
                functions[i],
                String.prototype[functions[i]]
              );
            }
            wrapper = function localeCompare(compareString, locales, options) {
              locales = thisInterpreter.pseudoToNative(locales);
              options = thisInterpreter.pseudoToNative(options);
              try {
                return String(this).localeCompare(compareString, locales, options);
              } catch (e) {
                thisInterpreter.throwException(
                  thisInterpreter.ERROR,
                  "localeCompare: " + e.message
                );
              }
            };
            this.setNativeFunctionPrototype(this.STRING, "localeCompare", wrapper);
            wrapper = function split(separator, limit, callback) {
              var string = String(this);
              limit = limit ? Number(limit) : void 0;
              if (thisInterpreter.isa(separator, thisInterpreter.REGEXP)) {
                separator = separator.data;
                thisInterpreter.maybeThrowRegExp(separator, callback);
                if (thisInterpreter["REGEXP_MODE"] === 2) {
                  if (Interpreter2.vm) {
                    var sandbox = {
                      "string": string,
                      "separator": separator,
                      "limit": limit
                    };
                    var code = "string.split(separator, limit)";
                    var jsList = thisInterpreter.vmCall(code, sandbox, separator, callback);
                    if (jsList !== Interpreter2.REGEXP_TIMEOUT) {
                      callback(thisInterpreter.arrayNativeToPseudo(jsList));
                    }
                  } else {
                    var splitWorker = thisInterpreter.createWorker();
                    var pid = thisInterpreter.regExpTimeout(
                      separator,
                      splitWorker,
                      callback
                    );
                    splitWorker.onmessage = function(e) {
                      clearTimeout(pid);
                      callback(thisInterpreter.arrayNativeToPseudo(e.data));
                    };
                    splitWorker.postMessage(["split", string, separator, limit]);
                  }
                  return;
                }
              }
              var jsList = string.split(separator, limit);
              callback(thisInterpreter.arrayNativeToPseudo(jsList));
            };
            this.setAsyncFunctionPrototype(this.STRING, "split", wrapper);
            wrapper = function match(regexp, callback) {
              var string = String(this);
              if (thisInterpreter.isa(regexp, thisInterpreter.REGEXP)) {
                regexp = regexp.data;
              } else {
                regexp = new RegExp(regexp);
              }
              thisInterpreter.maybeThrowRegExp(regexp, callback);
              if (thisInterpreter["REGEXP_MODE"] === 2) {
                if (Interpreter2.vm) {
                  var sandbox = {
                    "string": string,
                    "regexp": regexp
                  };
                  var code = "string.match(regexp)";
                  var m = thisInterpreter.vmCall(code, sandbox, regexp, callback);
                  if (m !== Interpreter2.REGEXP_TIMEOUT) {
                    callback(m && thisInterpreter.arrayNativeToPseudo(m));
                  }
                } else {
                  var matchWorker = thisInterpreter.createWorker();
                  var pid = thisInterpreter.regExpTimeout(regexp, matchWorker, callback);
                  matchWorker.onmessage = function(e) {
                    clearTimeout(pid);
                    callback(e.data && thisInterpreter.arrayNativeToPseudo(e.data));
                  };
                  matchWorker.postMessage(["match", string, regexp]);
                }
                return;
              }
              var m = string.match(regexp);
              callback(m && thisInterpreter.arrayNativeToPseudo(m));
            };
            this.setAsyncFunctionPrototype(this.STRING, "match", wrapper);
            wrapper = function search(regexp, callback) {
              var string = String(this);
              if (thisInterpreter.isa(regexp, thisInterpreter.REGEXP)) {
                regexp = regexp.data;
              } else {
                regexp = new RegExp(regexp);
              }
              thisInterpreter.maybeThrowRegExp(regexp, callback);
              if (thisInterpreter["REGEXP_MODE"] === 2) {
                if (Interpreter2.vm) {
                  var sandbox = {
                    "string": string,
                    "regexp": regexp
                  };
                  var code = "string.search(regexp)";
                  var n = thisInterpreter.vmCall(code, sandbox, regexp, callback);
                  if (n !== Interpreter2.REGEXP_TIMEOUT) {
                    callback(n);
                  }
                } else {
                  var searchWorker = thisInterpreter.createWorker();
                  var pid = thisInterpreter.regExpTimeout(regexp, searchWorker, callback);
                  searchWorker.onmessage = function(e) {
                    clearTimeout(pid);
                    callback(e.data);
                  };
                  searchWorker.postMessage(["search", string, regexp]);
                }
                return;
              }
              callback(string.search(regexp));
            };
            this.setAsyncFunctionPrototype(this.STRING, "search", wrapper);
            wrapper = function replace_(substr, newSubstr, callback) {
              var string = String(this);
              newSubstr = String(newSubstr);
              if (thisInterpreter.isa(substr, thisInterpreter.REGEXP)) {
                substr = substr.data;
                thisInterpreter.maybeThrowRegExp(substr, callback);
                if (thisInterpreter["REGEXP_MODE"] === 2) {
                  if (Interpreter2.vm) {
                    var sandbox = {
                      "string": string,
                      "substr": substr,
                      "newSubstr": newSubstr
                    };
                    var code = "string.replace(substr, newSubstr)";
                    var str = thisInterpreter.vmCall(code, sandbox, substr, callback);
                    if (str !== Interpreter2.REGEXP_TIMEOUT) {
                      callback(str);
                    }
                  } else {
                    var replaceWorker = thisInterpreter.createWorker();
                    var pid = thisInterpreter.regExpTimeout(
                      substr,
                      replaceWorker,
                      callback
                    );
                    replaceWorker.onmessage = function(e) {
                      clearTimeout(pid);
                      callback(e.data);
                    };
                    replaceWorker.postMessage(["replace", string, substr, newSubstr]);
                  }
                  return;
                }
              }
              callback(string.replace(substr, newSubstr));
            };
            this.setAsyncFunctionPrototype(this.STRING, "replace", wrapper);
            this.polyfills_.push(
              "(function() {",
              "var replace_ = String.prototype.replace;",
              "String.prototype.replace = function replace(substr, newSubstr) {",
              "if (typeof newSubstr !== 'function') {",
              "return replace_.call(this, substr, newSubstr);",
              "}",
              "var str = this;",
              "if (substr instanceof RegExp) {",
              "var subs = [];",
              "var m = substr.exec(str);",
              "while (m) {",
              "m.push(m.index, str);",
              "var inject = newSubstr.apply(null, m);",
              "subs.push([m.index, m[0].length, inject]);",
              "m = substr.global ? substr.exec(str) : null;",
              "}",
              "for (var i = subs.length - 1; i >= 0; i--) {",
              "str = str.substring(0, subs[i][0]) + subs[i][2] + str.substring(subs[i][0] + subs[i][1]);",
              "}",
              "} else {",
              "var i = str.indexOf(substr);",
              "if (i !== -1) {",
              "var inject = newSubstr(str.substr(i, substr.length), i, str);",
              "str = str.substring(0, i) + inject + str.substring(i + substr.length);",
              "}",
              "}",
              "return str;",
              "};",
              "})();",
              ""
            );
          };
          Interpreter2.prototype.initBoolean = function(globalObject) {
            var thisInterpreter = this;
            var wrapper;
            wrapper = function Boolean2(value) {
              value = Interpreter2.nativeGlobal.Boolean(value);
              if (thisInterpreter.calledWithNew()) {
                this.data = value;
                return this;
              } else {
                return value;
              }
            };
            this.BOOLEAN = this.createNativeFunction(wrapper, true);
            this.setProperty(
              globalObject,
              "Boolean",
              this.BOOLEAN,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
          };
          Interpreter2.prototype.initNumber = function(globalObject) {
            var thisInterpreter = this;
            var wrapper;
            wrapper = function Number2(value) {
              value = arguments.length ? Interpreter2.nativeGlobal.Number(value) : 0;
              if (thisInterpreter.calledWithNew()) {
                this.data = value;
                return this;
              } else {
                return value;
              }
            };
            this.NUMBER = this.createNativeFunction(wrapper, true);
            this.setProperty(
              globalObject,
              "Number",
              this.NUMBER,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            var numConsts = [
              "MAX_VALUE",
              "MIN_VALUE",
              "NaN",
              "NEGATIVE_INFINITY",
              "POSITIVE_INFINITY"
            ];
            for (var i = 0; i < numConsts.length; i++) {
              this.setProperty(
                this.NUMBER,
                numConsts[i],
                Number[numConsts[i]],
                Interpreter2.NONCONFIGURABLE_READONLY_NONENUMERABLE_DESCRIPTOR
              );
            }
            wrapper = function toExponential(fractionDigits) {
              try {
                return Number(this).toExponential(fractionDigits);
              } catch (e) {
                thisInterpreter.throwException(thisInterpreter.ERROR, e.message);
              }
            };
            this.setNativeFunctionPrototype(this.NUMBER, "toExponential", wrapper);
            wrapper = function toFixed(digits) {
              try {
                return Number(this).toFixed(digits);
              } catch (e) {
                thisInterpreter.throwException(thisInterpreter.ERROR, e.message);
              }
            };
            this.setNativeFunctionPrototype(this.NUMBER, "toFixed", wrapper);
            wrapper = function toPrecision(precision) {
              try {
                return Number(this).toPrecision(precision);
              } catch (e) {
                thisInterpreter.throwException(thisInterpreter.ERROR, e.message);
              }
            };
            this.setNativeFunctionPrototype(this.NUMBER, "toPrecision", wrapper);
            wrapper = function toString(radix) {
              try {
                return Number(this).toString(radix);
              } catch (e) {
                thisInterpreter.throwException(thisInterpreter.ERROR, e.message);
              }
            };
            this.setNativeFunctionPrototype(this.NUMBER, "toString", wrapper);
            wrapper = function toLocaleString(locales, options) {
              locales = locales ? thisInterpreter.pseudoToNative(locales) : void 0;
              options = options ? thisInterpreter.pseudoToNative(options) : void 0;
              return Number(this).toLocaleString(locales, options);
            };
            this.setNativeFunctionPrototype(this.NUMBER, "toLocaleString", wrapper);
          };
          Interpreter2.prototype.initDate = function(globalObject) {
            var thisInterpreter = this;
            var wrapper;
            wrapper = function Date2(_value, var_args) {
              if (!thisInterpreter.calledWithNew()) {
                return Interpreter2.nativeGlobal.Date();
              }
              var args = [null].concat(Array.from(arguments));
              this.data = new (Function.prototype.bind.apply(
                Interpreter2.nativeGlobal.Date,
                args
              ))();
              return this;
            };
            this.DATE = this.createNativeFunction(wrapper, true);
            this.DATE_PROTO = this.DATE.properties["prototype"];
            this.setProperty(
              globalObject,
              "Date",
              this.DATE,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.DATE,
              "now",
              this.createNativeFunction(Date.now, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.DATE,
              "parse",
              this.createNativeFunction(Date.parse, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.DATE,
              "UTC",
              this.createNativeFunction(Date.UTC, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            var functions = [
              "getDate",
              "getDay",
              "getFullYear",
              "getHours",
              "getMilliseconds",
              "getMinutes",
              "getMonth",
              "getSeconds",
              "getTime",
              "getTimezoneOffset",
              "getUTCDate",
              "getUTCDay",
              "getUTCFullYear",
              "getUTCHours",
              "getUTCMilliseconds",
              "getUTCMinutes",
              "getUTCMonth",
              "getUTCSeconds",
              "getYear",
              "setDate",
              "setFullYear",
              "setHours",
              "setMilliseconds",
              "setMinutes",
              "setMonth",
              "setSeconds",
              "setTime",
              "setUTCDate",
              "setUTCFullYear",
              "setUTCHours",
              "setUTCMilliseconds",
              "setUTCMinutes",
              "setUTCMonth",
              "setUTCSeconds",
              "setYear",
              "toDateString",
              "toISOString",
              "toJSON",
              "toGMTString",
              "toLocaleDateString",
              "toLocaleString",
              "toLocaleTimeString",
              "toTimeString",
              "toUTCString"
            ];
            for (var i = 0; i < functions.length; i++) {
              wrapper = function(nativeFunc) {
                return function(var_args) {
                  var date = this.data;
                  if (!(date instanceof Date)) {
                    thisInterpreter.throwException(
                      thisInterpreter.TYPE_ERROR,
                      nativeFunc + " not called on a Date"
                    );
                  }
                  var args = [];
                  for (var i2 = 0; i2 < arguments.length; i2++) {
                    args[i2] = thisInterpreter.pseudoToNative(arguments[i2]);
                  }
                  return date[nativeFunc].apply(date, args);
                };
              }(functions[i]);
              this.setNativeFunctionPrototype(this.DATE, functions[i], wrapper);
            }
          };
          Interpreter2.prototype.initRegExp = function(globalObject) {
            var thisInterpreter = this;
            var wrapper;
            wrapper = function RegExp2(pattern, flags) {
              if (thisInterpreter.calledWithNew()) {
                var rgx = this;
              } else {
                if (flags === void 0 && thisInterpreter.isa(pattern, thisInterpreter.REGEXP)) {
                  return pattern;
                }
                var rgx = thisInterpreter.createObjectProto(thisInterpreter.REGEXP_PROTO);
              }
              pattern = pattern === void 0 ? "" : String(pattern);
              flags = flags ? String(flags) : "";
              if (!/^[gmi]*$/.test(flags)) {
                thisInterpreter.throwException(thisInterpreter.SYNTAX_ERROR, "Invalid regexp flag");
              }
              try {
                var nativeRegExp = new Interpreter2.nativeGlobal.RegExp(pattern, flags);
              } catch (e) {
                thisInterpreter.throwException(thisInterpreter.SYNTAX_ERROR, e.message);
              }
              thisInterpreter.populateRegExp(rgx, nativeRegExp);
              return rgx;
            };
            this.REGEXP = this.createNativeFunction(wrapper, true);
            this.REGEXP_PROTO = this.REGEXP.properties["prototype"];
            this.setProperty(
              globalObject,
              "RegExp",
              this.REGEXP,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.REGEXP.properties["prototype"],
              "global",
              void 0,
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.REGEXP.properties["prototype"],
              "ignoreCase",
              void 0,
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.REGEXP.properties["prototype"],
              "multiline",
              void 0,
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.REGEXP.properties["prototype"],
              "source",
              "(?:)",
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
            this.polyfills_.push(
              "Object.defineProperty(RegExp.prototype, 'test',",
              "{configurable: true, writable: true, value:",
              "function test(str) {",
              "return !!this.exec(str);",
              "}",
              "});"
            );
            wrapper = function exec(string, callback) {
              var regexp = this.data;
              string = String(string);
              regexp.lastIndex = Number(thisInterpreter.getProperty(this, "lastIndex"));
              thisInterpreter.maybeThrowRegExp(regexp, callback);
              if (thisInterpreter["REGEXP_MODE"] === 2) {
                if (Interpreter2.vm) {
                  var sandbox = {
                    "string": string,
                    "regexp": regexp
                  };
                  var code = "regexp.exec(string)";
                  var match = thisInterpreter.vmCall(code, sandbox, regexp, callback);
                  if (match !== Interpreter2.REGEXP_TIMEOUT) {
                    thisInterpreter.setProperty(this, "lastIndex", regexp.lastIndex);
                    callback(matchToPseudo(match));
                  }
                } else {
                  var execWorker = thisInterpreter.createWorker();
                  var pid = thisInterpreter.regExpTimeout(regexp, execWorker, callback);
                  var thisPseudoRegExp = this;
                  execWorker.onmessage = function(e) {
                    clearTimeout(pid);
                    thisInterpreter.setProperty(thisPseudoRegExp, "lastIndex", e.data[1]);
                    callback(matchToPseudo(e.data[0]));
                  };
                  execWorker.postMessage(["exec", regexp, regexp.lastIndex, string]);
                }
                return;
              }
              var match = regexp.exec(string);
              thisInterpreter.setProperty(this, "lastIndex", regexp.lastIndex);
              callback(matchToPseudo(match));
              function matchToPseudo(match2) {
                if (match2) {
                  var result = thisInterpreter.arrayNativeToPseudo(match2);
                  thisInterpreter.setProperty(result, "index", match2.index);
                  thisInterpreter.setProperty(result, "input", match2.input);
                  return result;
                }
                return null;
              }
            };
            this.setAsyncFunctionPrototype(this.REGEXP, "exec", wrapper);
          };
          Interpreter2.prototype.initError = function(globalObject) {
            var thisInterpreter = this;
            this.ERROR = this.createNativeFunction(function Error2(opt_message) {
              if (thisInterpreter.calledWithNew()) {
                var newError = this;
              } else {
                var newError = thisInterpreter.createObject(thisInterpreter.ERROR);
              }
              thisInterpreter.populateError(newError, opt_message);
              return newError;
            }, true);
            this.setProperty(
              globalObject,
              "Error",
              this.ERROR,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.ERROR.properties["prototype"],
              "message",
              "",
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              this.ERROR.properties["prototype"],
              "name",
              "Error",
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            var createErrorSubclass = function(name) {
              var constructor = thisInterpreter.createNativeFunction(
                function(opt_message) {
                  if (thisInterpreter.calledWithNew()) {
                    var newError = this;
                  } else {
                    var newError = thisInterpreter.createObject(constructor);
                  }
                  thisInterpreter.populateError(newError, opt_message);
                  return newError;
                },
                true
              );
              thisInterpreter.setProperty(
                constructor,
                "prototype",
                thisInterpreter.createObject(thisInterpreter.ERROR),
                Interpreter2.NONENUMERABLE_DESCRIPTOR
              );
              thisInterpreter.setProperty(
                constructor.properties["prototype"],
                "name",
                name,
                Interpreter2.NONENUMERABLE_DESCRIPTOR
              );
              thisInterpreter.setProperty(
                globalObject,
                name,
                constructor,
                Interpreter2.NONENUMERABLE_DESCRIPTOR
              );
              return constructor;
            };
            this.EVAL_ERROR = createErrorSubclass("EvalError");
            this.RANGE_ERROR = createErrorSubclass("RangeError");
            this.REFERENCE_ERROR = createErrorSubclass("ReferenceError");
            this.SYNTAX_ERROR = createErrorSubclass("SyntaxError");
            this.TYPE_ERROR = createErrorSubclass("TypeError");
            this.URI_ERROR = createErrorSubclass("URIError");
          };
          Interpreter2.prototype.initMath = function(globalObject) {
            var myMath = this.createObjectProto(this.OBJECT_PROTO);
            this.setProperty(
              globalObject,
              "Math",
              myMath,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            var mathConsts = [
              "E",
              "LN2",
              "LN10",
              "LOG2E",
              "LOG10E",
              "PI",
              "SQRT1_2",
              "SQRT2"
            ];
            for (var i = 0; i < mathConsts.length; i++) {
              this.setProperty(
                myMath,
                mathConsts[i],
                Math[mathConsts[i]],
                Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
              );
            }
            var numFunctions = [
              "abs",
              "acos",
              "asin",
              "atan",
              "atan2",
              "ceil",
              "cos",
              "exp",
              "floor",
              "log",
              "max",
              "min",
              "pow",
              "random",
              "round",
              "sin",
              "sqrt",
              "tan"
            ];
            for (var i = 0; i < numFunctions.length; i++) {
              this.setProperty(
                myMath,
                numFunctions[i],
                this.createNativeFunction(Math[numFunctions[i]], false),
                Interpreter2.NONENUMERABLE_DESCRIPTOR
              );
            }
          };
          Interpreter2.prototype.initJSON = function(globalObject) {
            var thisInterpreter = this;
            var myJSON = thisInterpreter.createObjectProto(this.OBJECT_PROTO);
            this.setProperty(
              globalObject,
              "JSON",
              myJSON,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            var wrapper = function parse(text) {
              try {
                var nativeObj = JSON.parse(String(text));
              } catch (e) {
                thisInterpreter.throwException(thisInterpreter.SYNTAX_ERROR, e.message);
              }
              return thisInterpreter.nativeToPseudo(nativeObj);
            };
            this.setProperty(myJSON, "parse", this.createNativeFunction(wrapper, false));
            wrapper = function stringify(value, replacer, space) {
              if (replacer && replacer.class === "Function") {
                thisInterpreter.throwException(
                  thisInterpreter.TYPE_ERROR,
                  "Function replacer on JSON.stringify not supported"
                );
              } else if (replacer && replacer.class === "Array") {
                replacer = thisInterpreter.arrayPseudoToNative(replacer);
                replacer = replacer.filter(function(word) {
                  return typeof word === "string" || typeof word === "number";
                });
              } else {
                replacer = null;
              }
              if (typeof space !== "string" && typeof space !== "number") {
                space = void 0;
              }
              var nativeObj = thisInterpreter.pseudoToNative(value);
              try {
                var str = JSON.stringify(nativeObj, replacer, space);
              } catch (e) {
                thisInterpreter.throwException(thisInterpreter.TYPE_ERROR, e.message);
              }
              return str;
            };
            this.setProperty(
              myJSON,
              "stringify",
              this.createNativeFunction(wrapper, false)
            );
          };
          Interpreter2.prototype.isa = function(child, constructor) {
            if (child === null || child === void 0 || !constructor) {
              return false;
            }
            var proto = constructor.properties["prototype"];
            if (child === proto) {
              return true;
            }
            child = this.getPrototype(child);
            while (child) {
              if (child === proto) {
                return true;
              }
              child = child.proto;
            }
            return false;
          };
          Interpreter2.prototype.populateRegExp = function(pseudoRegexp, nativeRegexp) {
            pseudoRegexp.data = new RegExp(nativeRegexp.source, nativeRegexp.flags);
            this.setProperty(
              pseudoRegexp,
              "lastIndex",
              nativeRegexp.lastIndex,
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              pseudoRegexp,
              "source",
              nativeRegexp.source,
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              pseudoRegexp,
              "global",
              nativeRegexp.global,
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              pseudoRegexp,
              "ignoreCase",
              nativeRegexp.ignoreCase,
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
            this.setProperty(
              pseudoRegexp,
              "multiline",
              nativeRegexp.multiline,
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
          };
          Interpreter2.prototype.populateError = function(pseudoError, opt_message) {
            if (opt_message) {
              this.setProperty(
                pseudoError,
                "message",
                String(opt_message),
                Interpreter2.NONENUMERABLE_DESCRIPTOR
              );
            }
            var tracebackData = [];
            for (var i = this.stateStack.length - 1; i >= 0; i--) {
              var state = this.stateStack[i];
              var node = state.node;
              if (node["type"] === "CallExpression") {
                var func = state.func_;
                if (func && tracebackData.length) {
                  tracebackData[tracebackData.length - 1].datumName = this.getProperty(func, "name");
                }
              }
              if (node["loc"] && (!tracebackData.length || node["type"] === "CallExpression")) {
                tracebackData.push({ datumLoc: node["loc"] });
              }
            }
            var errorName = String(this.getProperty(pseudoError, "name"));
            var errorMessage = String(this.getProperty(pseudoError, "message"));
            var stackString = errorName + ": " + errorMessage + "\n";
            for (var i = 0; i < tracebackData.length; i++) {
              var loc = tracebackData[i].datumLoc;
              var name = tracebackData[i].datumName;
              var locString = loc["source"] + ":" + loc["start"]["line"] + ":" + loc["start"]["column"];
              if (name) {
                stackString += "  at " + name + " (" + locString + ")\n";
              } else {
                stackString += "  at " + locString + "\n";
              }
            }
            this.setProperty(
              pseudoError,
              "stack",
              stackString.trim(),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
          };
          Interpreter2.prototype.createWorker = function() {
            var blob = this.createWorker.blob_;
            if (!blob) {
              blob = new Blob(
                [Interpreter2.WORKER_CODE.join("\n")],
                { type: "application/javascript" }
              );
              this.createWorker.blob_ = blob;
            }
            return new Worker(URL.createObjectURL(blob));
          };
          Interpreter2.prototype.vmCall = function(code, sandbox, nativeRegExp, callback) {
            var options = { "timeout": this["REGEXP_THREAD_TIMEOUT"] };
            try {
              return Interpreter2.vm["runInNewContext"](code, sandbox, options);
            } catch (_e) {
              callback(null);
              this.throwException(this.ERROR, "RegExp Timeout: " + nativeRegExp);
            }
            return Interpreter2.REGEXP_TIMEOUT;
          };
          Interpreter2.prototype.maybeThrowRegExp = function(nativeRegExp, callback) {
            var ok;
            if (this["REGEXP_MODE"] === 0) {
              ok = false;
            } else if (this["REGEXP_MODE"] === 1) {
              ok = true;
            } else {
              if (Interpreter2.vm) {
                ok = true;
              } else if (typeof Worker === "function" && typeof URL === "function") {
                ok = true;
              } else {
                try {
                  Interpreter2.vm = __webpack_require__2("vm");
                } catch (_e) {
                }
                ok = !!Interpreter2.vm;
              }
            }
            if (!ok) {
              callback(null);
              this.throwException(this.ERROR, "Regular expressions not supported: " + nativeRegExp);
            }
          };
          Interpreter2.prototype.regExpTimeout = function(nativeRegExp, worker, callback) {
            var thisInterpreter = this;
            return setTimeout(function() {
              worker.terminate();
              callback(null);
              try {
                thisInterpreter.throwException(
                  thisInterpreter.ERROR,
                  "RegExp Timeout: " + nativeRegExp
                );
              } catch (_e) {
              }
            }, this["REGEXP_THREAD_TIMEOUT"]);
          };
          Interpreter2.prototype.createObject = function(constructor) {
            return this.createObjectProto(constructor && constructor.properties["prototype"]);
          };
          Interpreter2.prototype.createObjectProto = function(proto) {
            if (typeof proto !== "object") {
              throw Error("Non object prototype");
            }
            var obj = new Interpreter2.Object(proto);
            if (this.isa(obj, this.ERROR)) {
              obj.class = "Error";
            }
            return obj;
          };
          Interpreter2.prototype.createArray = function() {
            var array = this.createObjectProto(this.ARRAY_PROTO);
            this.setProperty(
              array,
              "length",
              0,
              { configurable: false, enumerable: false, writable: true }
            );
            array.class = "Array";
            return array;
          };
          Interpreter2.prototype.createFunctionBase_ = function(argumentLength, isConstructor) {
            var func = this.createObjectProto(this.FUNCTION_PROTO);
            if (isConstructor) {
              var proto = this.createObjectProto(this.OBJECT_PROTO);
              this.setProperty(
                func,
                "prototype",
                proto,
                Interpreter2.NONENUMERABLE_DESCRIPTOR
              );
              this.setProperty(
                proto,
                "constructor",
                func,
                Interpreter2.NONENUMERABLE_DESCRIPTOR
              );
            } else {
              func.illegalConstructor = true;
            }
            this.setProperty(
              func,
              "length",
              argumentLength,
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
            func.class = "Function";
            return func;
          };
          Interpreter2.prototype.createFunction = function(node, scope, opt_name) {
            var func = this.createFunctionBase_(node["params"].length, true);
            func.parentScope = scope;
            func.node = node;
            var name = node["id"] ? String(node["id"]["name"]) : opt_name || "";
            this.setProperty(
              func,
              "name",
              name,
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
            return func;
          };
          Interpreter2.prototype.createNativeFunction = function(nativeFunc, isConstructor) {
            var func = this.createFunctionBase_(nativeFunc.length, isConstructor);
            func.nativeFunc = nativeFunc;
            nativeFunc.id = this.functionCounter_++;
            this.setProperty(
              func,
              "name",
              nativeFunc.name,
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
            return func;
          };
          Interpreter2.prototype.createAsyncFunction = function(asyncFunc) {
            var func = this.createFunctionBase_(asyncFunc.length, true);
            func.asyncFunc = asyncFunc;
            asyncFunc.id = this.functionCounter_++;
            this.setProperty(
              func,
              "name",
              asyncFunc.name,
              Interpreter2.READONLY_NONENUMERABLE_DESCRIPTOR
            );
            return func;
          };
          Interpreter2.prototype.nativeToPseudo = function(nativeObj) {
            if (nativeObj instanceof Interpreter2.Object) {
              throw Error("Object is already pseudo");
            }
            if (typeof nativeObj !== "object" && typeof nativeObj !== "function" || nativeObj === null) {
              return nativeObj;
            }
            if (nativeObj instanceof RegExp) {
              var pseudoRegexp = this.createObjectProto(this.REGEXP_PROTO);
              this.populateRegExp(pseudoRegexp, nativeObj);
              return pseudoRegexp;
            }
            if (nativeObj instanceof Date) {
              var pseudoDate = this.createObjectProto(this.DATE_PROTO);
              pseudoDate.data = new Date(nativeObj.valueOf());
              return pseudoDate;
            }
            if (typeof nativeObj === "function") {
              var thisInterpreter = this;
              var wrapper = function() {
                var args = Array.prototype.slice.call(arguments).map(function(i2) {
                  return thisInterpreter.pseudoToNative(i2);
                });
                var value = nativeObj.apply(thisInterpreter, args);
                return thisInterpreter.nativeToPseudo(value);
              };
              var prototype = Object.getOwnPropertyDescriptor(nativeObj, "prototype");
              return this.createNativeFunction(wrapper, !!prototype);
            }
            if (Array.isArray(nativeObj)) {
              var pseudoArray = this.createArray();
              for (var i = 0; i < nativeObj.length; i++) {
                if (i in nativeObj) {
                  this.setProperty(pseudoArray, i, this.nativeToPseudo(nativeObj[i]));
                }
              }
              return pseudoArray;
            }
            var pseudoObj = this.createObjectProto(this.OBJECT_PROTO);
            for (var key in nativeObj) {
              this.setProperty(pseudoObj, key, this.nativeToPseudo(nativeObj[key]));
            }
            return pseudoObj;
          };
          Interpreter2.prototype.pseudoToNative = function(pseudoObj, opt_cycles) {
            if (typeof pseudoObj !== "object" && typeof pseudoObj !== "function" || pseudoObj === null) {
              return pseudoObj;
            }
            if (!(pseudoObj instanceof Interpreter2.Object)) {
              throw Error("Object is not pseudo");
            }
            if (this.isa(pseudoObj, this.REGEXP)) {
              var nativeRegExp = new RegExp(pseudoObj.data.source, pseudoObj.data.flags);
              nativeRegExp.lastIndex = pseudoObj.data.lastIndex;
              return nativeRegExp;
            }
            if (this.isa(pseudoObj, this.DATE)) {
              return new Date(pseudoObj.data.valueOf());
            }
            var cycles = opt_cycles || {
              pseudo: [],
              native: []
            };
            var index = cycles.pseudo.indexOf(pseudoObj);
            if (index !== -1) {
              return cycles.native[index];
            }
            cycles.pseudo.push(pseudoObj);
            var nativeObj;
            if (this.isa(pseudoObj, this.ARRAY)) {
              nativeObj = [];
              cycles.native.push(nativeObj);
              var len = this.getProperty(pseudoObj, "length");
              for (var i = 0; i < len; i++) {
                if (this.hasProperty(pseudoObj, i)) {
                  nativeObj[i] = this.pseudoToNative(this.getProperty(pseudoObj, i), cycles);
                }
              }
            } else {
              nativeObj = {};
              cycles.native.push(nativeObj);
              var val;
              for (var key in pseudoObj.properties) {
                val = this.pseudoToNative(pseudoObj.properties[key], cycles);
                Object.defineProperty(
                  nativeObj,
                  key,
                  { value: val, writable: true, enumerable: true, configurable: true }
                );
              }
            }
            cycles.pseudo.pop();
            cycles.native.pop();
            return nativeObj;
          };
          Interpreter2.prototype.arrayNativeToPseudo = function(nativeArray) {
            var pseudoArray = this.createArray();
            var props = Object.getOwnPropertyNames(nativeArray);
            for (var i = 0; i < props.length; i++) {
              this.setProperty(pseudoArray, props[i], nativeArray[props[i]]);
            }
            return pseudoArray;
          };
          Interpreter2.prototype.arrayPseudoToNative = function(pseudoArray) {
            var nativeArray = [];
            for (var key in pseudoArray.properties) {
              nativeArray[key] = this.getProperty(pseudoArray, key);
            }
            nativeArray.length = Interpreter2.legalArrayLength(
              this.getProperty(pseudoArray, "length")
            ) || 0;
            return nativeArray;
          };
          Interpreter2.prototype.getPrototype = function(value) {
            switch (typeof value) {
              case "number":
                return this.NUMBER.properties["prototype"];
              case "boolean":
                return this.BOOLEAN.properties["prototype"];
              case "string":
                return this.STRING.properties["prototype"];
            }
            if (value) {
              return value.proto;
            }
            return null;
          };
          Interpreter2.prototype.getProperty = function(obj, name) {
            if (this.getterStep_) {
              throw Error("Getter not supported in that context");
            }
            name = String(name);
            if (obj === void 0 || obj === null) {
              this.throwException(
                this.TYPE_ERROR,
                "Cannot read property '" + name + "' of " + obj
              );
            }
            if (typeof obj === "object" && !(obj instanceof Interpreter2.Object)) {
              throw TypeError("Expecting native value or pseudo object");
            }
            if (name === "length") {
              if (this.isa(obj, this.STRING)) {
                return String(obj).length;
              }
            } else if (name.charCodeAt(0) < 64) {
              if (this.isa(obj, this.STRING)) {
                var n = Interpreter2.legalArrayIndex(name);
                if (!isNaN(n) && n < String(obj).length) {
                  return String(obj)[n];
                }
              }
            }
            do {
              if (obj.properties && name in obj.properties) {
                var getter = obj.getter[name];
                if (getter) {
                  this.getterStep_ = true;
                  return getter;
                }
                return obj.properties[name];
              }
            } while (obj = this.getPrototype(obj));
            return void 0;
          };
          Interpreter2.prototype.hasProperty = function(obj, name) {
            if (!(obj instanceof Interpreter2.Object)) {
              throw TypeError("Primitive data type has no properties");
            }
            name = String(name);
            if (name === "length" && this.isa(obj, this.STRING)) {
              return true;
            }
            if (this.isa(obj, this.STRING)) {
              var n = Interpreter2.legalArrayIndex(name);
              if (!isNaN(n) && n < String(obj).length) {
                return true;
              }
            }
            do {
              if (obj.properties && name in obj.properties) {
                return true;
              }
            } while (obj = this.getPrototype(obj));
            return false;
          };
          Interpreter2.prototype.setProperty = function(obj, name, value, opt_descriptor) {
            if (this.setterStep_) {
              throw Error("Setter not supported in that context");
            }
            name = String(name);
            if (obj === void 0 || obj === null) {
              this.throwException(
                this.TYPE_ERROR,
                "Cannot set property '" + name + "' of " + obj
              );
            }
            if (typeof obj === "object" && !(obj instanceof Interpreter2.Object)) {
              throw TypeError("Expecting native value or pseudo object");
            }
            if (opt_descriptor && ("get" in opt_descriptor || "set" in opt_descriptor) && ("value" in opt_descriptor || "writable" in opt_descriptor)) {
              this.throwException(this.TYPE_ERROR, "Invalid property descriptor. Cannot both specify accessors and a value or writable attribute");
            }
            var strict = !this.stateStack || this.getScope().strict;
            if (!(obj instanceof Interpreter2.Object)) {
              if (strict) {
                this.throwException(this.TYPE_ERROR, "Can't create property '" + name + "' on '" + obj + "'");
              }
              return;
            }
            if (this.isa(obj, this.STRING)) {
              var n = Interpreter2.legalArrayIndex(name);
              if (name === "length" || !isNaN(n) && n < String(obj).length) {
                if (strict) {
                  this.throwException(this.TYPE_ERROR, "Cannot assign to read only property '" + name + "' of String '" + obj.data + "'");
                }
                return;
              }
            }
            if (obj.class === "Array") {
              var len = obj.properties.length;
              var i;
              if (name === "length") {
                if (opt_descriptor) {
                  if (!("value" in opt_descriptor)) {
                    return;
                  }
                  value = opt_descriptor.value;
                }
                value = Interpreter2.legalArrayLength(value);
                if (isNaN(value)) {
                  this.throwException(this.RANGE_ERROR, "Invalid array length");
                }
                if (value < len) {
                  for (i in obj.properties) {
                    i = Interpreter2.legalArrayIndex(i);
                    if (!isNaN(i) && value <= i) {
                      delete obj.properties[i];
                    }
                  }
                }
              } else if (!isNaN(i = Interpreter2.legalArrayIndex(name))) {
                obj.properties.length = Math.max(len, i + 1);
              }
            }
            if (obj.preventExtensions && !(name in obj.properties)) {
              if (strict) {
                this.throwException(this.TYPE_ERROR, "Can't add property '" + name + "', object is not extensible");
              }
              return;
            }
            if (opt_descriptor) {
              var descriptor = {};
              if ("get" in opt_descriptor && opt_descriptor.get) {
                obj.getter[name] = opt_descriptor.get;
                descriptor.get = this.setProperty.placeholderGet_;
              }
              if ("set" in opt_descriptor && opt_descriptor.set) {
                obj.setter[name] = opt_descriptor.set;
                descriptor.set = this.setProperty.placeholderSet_;
              }
              if ("configurable" in opt_descriptor) {
                descriptor.configurable = opt_descriptor.configurable;
              }
              if ("enumerable" in opt_descriptor) {
                descriptor.enumerable = opt_descriptor.enumerable;
              }
              if ("writable" in opt_descriptor) {
                descriptor.writable = opt_descriptor.writable;
                delete obj.getter[name];
                delete obj.setter[name];
              }
              if ("value" in opt_descriptor) {
                descriptor.value = opt_descriptor.value;
                delete obj.getter[name];
                delete obj.setter[name];
              } else if (value !== Interpreter2.VALUE_IN_DESCRIPTOR) {
                descriptor.value = value;
                delete obj.getter[name];
                delete obj.setter[name];
              }
              try {
                Object.defineProperty(obj.properties, name, descriptor);
              } catch (e) {
                this.throwException(this.TYPE_ERROR, "Cannot redefine property: " + name);
              }
              if ("get" in opt_descriptor && !opt_descriptor.get) {
                delete obj.getter[name];
              }
              if ("set" in opt_descriptor && !opt_descriptor.set) {
                delete obj.setter[name];
              }
            } else {
              if (value === Interpreter2.VALUE_IN_DESCRIPTOR) {
                throw ReferenceError("Value not specified");
              }
              var defObj = obj;
              while (!(name in defObj.properties)) {
                defObj = this.getPrototype(defObj);
                if (!defObj) {
                  defObj = obj;
                  break;
                }
              }
              if (defObj.setter && defObj.setter[name]) {
                this.setterStep_ = true;
                return defObj.setter[name];
              }
              if (defObj.getter && defObj.getter[name]) {
                if (strict) {
                  this.throwException(this.TYPE_ERROR, "Cannot set property '" + name + "' of object '" + obj + "' which only has a getter");
                }
              } else {
                try {
                  obj.properties[name] = value;
                } catch (_e) {
                  if (strict) {
                    this.throwException(this.TYPE_ERROR, "Cannot assign to read only property '" + name + "' of object '" + obj + "'");
                  }
                }
              }
            }
          };
          Interpreter2.prototype.setProperty.placeholderGet_ = function() {
            throw Error("Placeholder getter");
          };
          Interpreter2.prototype.setProperty.placeholderSet_ = function() {
            throw Error("Placeholder setter");
          };
          Interpreter2.prototype.setNativeFunctionPrototype = function(obj, name, wrapper) {
            this.setProperty(
              obj.properties["prototype"],
              name,
              this.createNativeFunction(wrapper, false),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
          };
          Interpreter2.prototype.setAsyncFunctionPrototype = function(obj, name, wrapper) {
            this.setProperty(
              obj.properties["prototype"],
              name,
              this.createAsyncFunction(wrapper),
              Interpreter2.NONENUMERABLE_DESCRIPTOR
            );
          };
          Interpreter2.prototype.getScope = function() {
            var scope = this.stateStack[this.stateStack.length - 1].scope;
            if (!scope) {
              throw Error("No scope found");
            }
            return scope;
          };
          Interpreter2.prototype.createScope = function(node, parentScope) {
            var strict = false;
            if (parentScope && parentScope.strict) {
              strict = true;
            } else {
              var firstNode = node["body"] && node["body"][0];
              if (firstNode && firstNode.expression && firstNode.expression["type"] === "Literal" && firstNode.expression.value === "use strict") {
                strict = true;
              }
            }
            var object = this.createObjectProto(null);
            var scope = new Interpreter2.Scope(parentScope, strict, object);
            if (!parentScope) {
              this.initGlobal(scope.object);
            }
            this.populateScope_(node, scope);
            return scope;
          };
          Interpreter2.prototype.createSpecialScope = function(parentScope, opt_object) {
            if (!parentScope) {
              throw Error("parentScope required");
            }
            var object = opt_object || this.createObjectProto(null);
            return new Interpreter2.Scope(parentScope, parentScope.strict, object);
          };
          Interpreter2.prototype.getValueFromScope = function(name) {
            var scope = this.getScope();
            while (scope && scope !== this.globalScope) {
              if (name in scope.object.properties) {
                return scope.object.properties[name];
              }
              scope = scope.parentScope;
            }
            if (scope === this.globalScope && this.hasProperty(scope.object, name)) {
              return this.getProperty(scope.object, name);
            }
            var prevNode = this.stateStack[this.stateStack.length - 1].node;
            if (prevNode["type"] === "UnaryExpression" && prevNode["operator"] === "typeof") {
              return void 0;
            }
            this.throwException(this.REFERENCE_ERROR, name + " is not defined");
          };
          Interpreter2.prototype.setValueToScope = function(name, value) {
            var scope = this.getScope();
            var strict = scope.strict;
            while (scope && scope !== this.globalScope) {
              if (name in scope.object.properties) {
                scope.object.properties[name] = value;
                return void 0;
              }
              scope = scope.parentScope;
            }
            if (scope === this.globalScope && (!strict || this.hasProperty(scope.object, name))) {
              return this.setProperty(scope.object, name, value);
            }
            this.throwException(this.REFERENCE_ERROR, name + " is not defined");
          };
          Interpreter2.prototype.populateScope_ = function(node, scope) {
            var variableCache;
            if (!node.variableCache_) {
              variableCache = /* @__PURE__ */ Object.create(null);
              switch (node["type"]) {
                case "VariableDeclaration":
                  for (var i = 0; i < node["declarations"].length; i++) {
                    variableCache[node["declarations"][i]["id"]["name"]] = true;
                  }
                  break;
                case "FunctionDeclaration":
                  variableCache[node["id"]["name"]] = node;
                  break;
                case "BlockStatement":
                case "CatchClause":
                case "DoWhileStatement":
                case "ForInStatement":
                case "ForStatement":
                case "IfStatement":
                case "LabeledStatement":
                case "Program":
                case "SwitchCase":
                case "SwitchStatement":
                case "TryStatement":
                case "WithStatement":
                case "WhileStatement":
                  var nodeClass = node["constructor"];
                  for (var name in node) {
                    if (name === "loc")
                      continue;
                    var prop = node[name];
                    if (prop && typeof prop === "object") {
                      var childCache;
                      if (Array.isArray(prop)) {
                        for (var i = 0; i < prop.length; i++) {
                          if (prop[i] && prop[i].constructor === nodeClass) {
                            childCache = this.populateScope_(prop[i], scope);
                            for (var name in childCache) {
                              variableCache[name] = childCache[name];
                            }
                          }
                        }
                      } else {
                        if (prop.constructor === nodeClass) {
                          childCache = this.populateScope_(prop, scope);
                          for (var name in childCache) {
                            variableCache[name] = childCache[name];
                          }
                        }
                      }
                    }
                  }
              }
              node.variableCache_ = variableCache;
            } else {
              variableCache = node.variableCache_;
            }
            for (var name in variableCache) {
              if (variableCache[name] === true) {
                this.setProperty(
                  scope.object,
                  name,
                  void 0,
                  Interpreter2.VARIABLE_DESCRIPTOR
                );
              } else {
                this.setProperty(
                  scope.object,
                  name,
                  this.createFunction(variableCache[name], scope),
                  Interpreter2.VARIABLE_DESCRIPTOR
                );
              }
            }
            return variableCache;
          };
          Interpreter2.prototype.calledWithNew = function() {
            return this.stateStack[this.stateStack.length - 1].isConstructor;
          };
          Interpreter2.prototype.getValue = function(ref) {
            if (ref[0] === Interpreter2.SCOPE_REFERENCE) {
              return this.getValueFromScope(ref[1]);
            } else {
              return this.getProperty(ref[0], ref[1]);
            }
          };
          Interpreter2.prototype.setValue = function(ref, value) {
            if (ref[0] === Interpreter2.SCOPE_REFERENCE) {
              return this.setValueToScope(ref[1], value);
            } else {
              return this.setProperty(ref[0], ref[1], value);
            }
          };
          Interpreter2.prototype.throwException = function(errorClass, opt_message) {
            if (!this.globalScope) {
              throw opt_message === void 0 ? errorClass : opt_message;
            }
            if (opt_message === void 0) {
              var error = errorClass;
            } else {
              var error = this.createObject(errorClass);
              this.populateError(error, opt_message);
            }
            this.unwind(Interpreter2.Completion.THROW, error, void 0);
            throw Interpreter2.STEP_ERROR;
          };
          Interpreter2.prototype.unwind = function(type, value, label) {
            if (type === Interpreter2.Completion.NORMAL) {
              throw TypeError("Should not unwind for NORMAL completions");
            }
            loop:
              for (var stack = this.stateStack; stack.length > 0; stack.pop()) {
                var state = stack[stack.length - 1];
                switch (state.node["type"]) {
                  case "TryStatement":
                    state.cv = { type, value, label };
                    return;
                  case "CallExpression":
                  case "NewExpression":
                    if (type === Interpreter2.Completion.RETURN) {
                      state.value = value;
                      return;
                    } else if (type !== Interpreter2.Completion.THROW) {
                      throw Error("Unsynatctic break/continue not rejected by Acorn");
                    }
                    break;
                  case "Program":
                    state.done = true;
                    break loop;
                }
                if (type === Interpreter2.Completion.BREAK) {
                  if (label ? state.labels && state.labels.indexOf(label) !== -1 : state.isLoop || state.isSwitch) {
                    stack.pop();
                    return;
                  }
                } else if (type === Interpreter2.Completion.CONTINUE) {
                  if (label ? state.labels && state.labels.indexOf(label) !== -1 : state.isLoop) {
                    return;
                  }
                }
              }
            var realError;
            if (this.isa(value, this.ERROR)) {
              var errorTable = {
                "EvalError": EvalError,
                "RangeError": RangeError,
                "ReferenceError": ReferenceError,
                "SyntaxError": SyntaxError,
                "TypeError": TypeError,
                "URIError": URIError
              };
              var name = String(this.getProperty(value, "name"));
              var message = this.getProperty(value, "message").valueOf();
              var errorConstructor = errorTable[name] || Error;
              realError = errorConstructor(message);
              realError.stack = String(this.getProperty(value, "stack"));
            } else {
              realError = String(value);
            }
            throw realError;
          };
          Interpreter2.prototype.createGetter_ = function(func, left) {
            if (!this.getterStep_) {
              throw Error("Unexpected call to createGetter");
            }
            this.getterStep_ = false;
            var funcThis = Array.isArray(left) ? left[0] : left;
            var node = new this.newNode();
            node["type"] = "CallExpression";
            var state = new Interpreter2.State(
              node,
              this.stateStack[this.stateStack.length - 1].scope
            );
            state.doneCallee_ = 2;
            state.funcThis_ = funcThis;
            state.func_ = func;
            state.doneArgs_ = true;
            state.arguments_ = [];
            return state;
          };
          Interpreter2.prototype.createSetter_ = function(func, left, value) {
            if (!this.setterStep_) {
              throw Error("Unexpected call to createSetter");
            }
            this.setterStep_ = false;
            var funcThis = Array.isArray(left) ? left[0] : this.globalObject;
            var node = new this.newNode();
            node["type"] = "CallExpression";
            var state = new Interpreter2.State(
              node,
              this.stateStack[this.stateStack.length - 1].scope
            );
            state.doneCallee_ = 2;
            state.funcThis_ = funcThis;
            state.func_ = func;
            state.doneArgs_ = true;
            state.arguments_ = [value];
            return state;
          };
          Interpreter2.prototype.boxThis_ = function(value) {
            if (value === void 0 || value === null) {
              return this.globalObject;
            }
            if (!(value instanceof Interpreter2.Object)) {
              var box = this.createObjectProto(this.getPrototype(value));
              box.data = value;
              return box;
            }
            return value;
          };
          Interpreter2.prototype.getGlobalScope = function() {
            return this.globalScope;
          };
          Interpreter2.prototype.getStateStack = function() {
            return this.stateStack;
          };
          Interpreter2.prototype.setStateStack = function(newStack) {
            this.stateStack = newStack;
          };
          Interpreter2.Value;
          Interpreter2.State = function(node, scope) {
            this.node = node;
            this.scope = scope;
          };
          Interpreter2.Scope = function(parentScope, strict, object) {
            this.parentScope = parentScope;
            this.strict = strict;
            this.object = object;
          };
          Interpreter2.Object = function(proto) {
            this.getter = /* @__PURE__ */ Object.create(null);
            this.setter = /* @__PURE__ */ Object.create(null);
            this.properties = /* @__PURE__ */ Object.create(null);
            this.proto = proto;
          };
          Interpreter2.Object.prototype.proto = null;
          Interpreter2.Object.prototype.class = "Object";
          Interpreter2.Object.prototype.data = null;
          Interpreter2.Object.prototype.toString = function() {
            if (!Interpreter2.currentInterpreter_) {
              return "[object Interpreter.Object]";
            }
            if (!(this instanceof Interpreter2.Object)) {
              return String(this);
            }
            if (this.class === "Array") {
              var cycles = Interpreter2.toStringCycles_;
              cycles.push(this);
              try {
                var strs = [];
                var maxLength = this.properties.length;
                var truncated = false;
                if (maxLength > 1024) {
                  maxLength = 1e3;
                  truncated = true;
                }
                for (var i = 0; i < maxLength; i++) {
                  var value = this.properties[i];
                  strs[i] = value instanceof Interpreter2.Object && cycles.indexOf(value) !== -1 ? "..." : value;
                }
                if (truncated) {
                  strs.push("...");
                }
              } finally {
                cycles.pop();
              }
              return strs.join(",");
            }
            if (this.class === "Error") {
              var cycles = Interpreter2.toStringCycles_;
              if (cycles.indexOf(this) !== -1) {
                return "[object Error]";
              }
              var name, message;
              var obj = this;
              do {
                if ("name" in obj.properties) {
                  name = obj.properties["name"];
                  break;
                }
              } while (obj = obj.proto);
              obj = this;
              do {
                if ("message" in obj.properties) {
                  message = obj.properties["message"];
                  break;
                }
              } while (obj = obj.proto);
              cycles.push(this);
              try {
                name = name && String(name);
                message = message && String(message);
              } finally {
                cycles.pop();
              }
              return message ? name + ": " + message : String(name);
            }
            if (this.data !== null) {
              return String(this.data);
            }
            return "[object " + this.class + "]";
          };
          Interpreter2.Object.prototype.valueOf = function() {
            var callingInterpreter = Interpreter2.currentInterpreter_;
            if (!callingInterpreter) {
              return this;
            }
            if (this.data === void 0 || this.data === null || this.data instanceof RegExp) {
              return this;
            }
            if (this.data instanceof Date) {
              return this.data.valueOf();
            }
            return this.data;
          };
          Interpreter2.prototype["stepArrayExpression"] = function(stack, state, node) {
            var elements = node["elements"];
            var n = state.n_ || 0;
            if (!state.array_) {
              state.array_ = this.createArray();
              state.array_.properties.length = elements.length;
            } else {
              this.setProperty(state.array_, n, state.value);
              n++;
            }
            while (n < elements.length) {
              if (elements[n]) {
                state.n_ = n;
                return new Interpreter2.State(elements[n], state.scope);
              }
              n++;
            }
            stack.pop();
            stack[stack.length - 1].value = state.array_;
          };
          Interpreter2.prototype["stepAssignmentExpression"] = function(stack, state, node) {
            if (!state.doneLeft_) {
              state.doneLeft_ = true;
              var nextState = new Interpreter2.State(node["left"], state.scope);
              nextState.components = true;
              return nextState;
            }
            if (!state.doneRight_) {
              if (!state.leftReference_) {
                state.leftReference_ = state.value;
              }
              if (state.doneGetter_) {
                state.leftValue_ = state.value;
              }
              if (!state.doneGetter_ && node["operator"] !== "=") {
                var leftValue = this.getValue(state.leftReference_);
                state.leftValue_ = leftValue;
                if (this.getterStep_) {
                  state.doneGetter_ = true;
                  var func = leftValue;
                  return this.createGetter_(func, state.leftReference_);
                }
              }
              state.doneRight_ = true;
              if (node["operator"] === "=" && node["left"]["type"] === "Identifier") {
                state.destinationName = node["left"]["name"];
              }
              return new Interpreter2.State(node["right"], state.scope);
            }
            if (state.doneSetter_) {
              stack.pop();
              stack[stack.length - 1].value = state.setterValue_;
              return;
            }
            var value = state.leftValue_;
            var rightValue = state.value;
            switch (node["operator"]) {
              case "=":
                value = rightValue;
                break;
              case "+=":
                value += rightValue;
                break;
              case "-=":
                value -= rightValue;
                break;
              case "*=":
                value *= rightValue;
                break;
              case "/=":
                value /= rightValue;
                break;
              case "%=":
                value %= rightValue;
                break;
              case "<<=":
                value <<= rightValue;
                break;
              case ">>=":
                value >>= rightValue;
                break;
              case ">>>=":
                value >>>= rightValue;
                break;
              case "&=":
                value &= rightValue;
                break;
              case "^=":
                value ^= rightValue;
                break;
              case "|=":
                value |= rightValue;
                break;
              default:
                throw SyntaxError("Unknown assignment expression: " + node["operator"]);
            }
            var setter = this.setValue(state.leftReference_, value);
            if (setter) {
              state.doneSetter_ = true;
              state.setterValue_ = value;
              return this.createSetter_(setter, state.leftReference_, value);
            }
            stack.pop();
            stack[stack.length - 1].value = value;
          };
          Interpreter2.prototype["stepBinaryExpression"] = function(stack, state, node) {
            if (!state.doneLeft_) {
              state.doneLeft_ = true;
              return new Interpreter2.State(node["left"], state.scope);
            }
            if (!state.doneRight_) {
              state.doneRight_ = true;
              state.leftValue_ = state.value;
              return new Interpreter2.State(node["right"], state.scope);
            }
            stack.pop();
            var leftValue = state.leftValue_;
            var rightValue = state.value;
            var value;
            switch (node["operator"]) {
              case "==":
                value = leftValue == rightValue;
                break;
              case "!=":
                value = leftValue != rightValue;
                break;
              case "===":
                value = leftValue === rightValue;
                break;
              case "!==":
                value = leftValue !== rightValue;
                break;
              case ">":
                value = leftValue > rightValue;
                break;
              case ">=":
                value = leftValue >= rightValue;
                break;
              case "<":
                value = leftValue < rightValue;
                break;
              case "<=":
                value = leftValue <= rightValue;
                break;
              case "+":
                value = leftValue + rightValue;
                break;
              case "-":
                value = leftValue - rightValue;
                break;
              case "*":
                value = leftValue * rightValue;
                break;
              case "/":
                value = leftValue / rightValue;
                break;
              case "%":
                value = leftValue % rightValue;
                break;
              case "&":
                value = leftValue & rightValue;
                break;
              case "|":
                value = leftValue | rightValue;
                break;
              case "^":
                value = leftValue ^ rightValue;
                break;
              case "<<":
                value = leftValue << rightValue;
                break;
              case ">>":
                value = leftValue >> rightValue;
                break;
              case ">>>":
                value = leftValue >>> rightValue;
                break;
              case "in":
                if (!(rightValue instanceof Interpreter2.Object)) {
                  this.throwException(
                    this.TYPE_ERROR,
                    "'in' expects an object, not '" + rightValue + "'"
                  );
                }
                value = this.hasProperty(rightValue, leftValue);
                break;
              case "instanceof":
                if (!this.isa(rightValue, this.FUNCTION)) {
                  this.throwException(
                    this.TYPE_ERROR,
                    "Right-hand side of instanceof is not an object"
                  );
                }
                value = leftValue instanceof Interpreter2.Object ? this.isa(leftValue, rightValue) : false;
                break;
              default:
                throw SyntaxError("Unknown binary operator: " + node["operator"]);
            }
            stack[stack.length - 1].value = value;
          };
          Interpreter2.prototype["stepBlockStatement"] = function(stack, state, node) {
            var n = state.n_ || 0;
            var expression = node["body"][n];
            if (expression) {
              state.n_ = n + 1;
              return new Interpreter2.State(expression, state.scope);
            }
            stack.pop();
          };
          Interpreter2.prototype["stepBreakStatement"] = function(stack, state, node) {
            var label = node["label"] && node["label"]["name"];
            this.unwind(Interpreter2.Completion.BREAK, void 0, label);
          };
          Interpreter2.prototype.evalCodeNumber_ = 0;
          Interpreter2.prototype["stepCallExpression"] = function(stack, state, node) {
            if (!state.doneCallee_) {
              state.doneCallee_ = 1;
              var nextState = new Interpreter2.State(node["callee"], state.scope);
              nextState.components = true;
              return nextState;
            }
            if (state.doneCallee_ === 1) {
              state.doneCallee_ = 2;
              var func = state.value;
              if (Array.isArray(func)) {
                state.func_ = this.getValue(func);
                if (func[0] === Interpreter2.SCOPE_REFERENCE) {
                  state.directEval_ = func[1] === "eval";
                } else {
                  state.funcThis_ = func[0];
                }
                func = state.func_;
                if (this.getterStep_) {
                  state.doneCallee_ = 1;
                  return this.createGetter_(
                    func,
                    state.value
                  );
                }
              } else {
                state.func_ = func;
              }
              state.arguments_ = [];
              state.n_ = 0;
            }
            var func = state.func_;
            if (!state.doneArgs_) {
              if (state.n_ !== 0) {
                state.arguments_.push(state.value);
              }
              if (node["arguments"][state.n_]) {
                return new Interpreter2.State(node["arguments"][state.n_++], state.scope);
              }
              if (node["type"] === "NewExpression") {
                if (!(func instanceof Interpreter2.Object) || func.illegalConstructor) {
                  this.throwException(this.TYPE_ERROR, func + " is not a constructor");
                }
                if (func === this.ARRAY) {
                  state.funcThis_ = this.createArray();
                } else {
                  var proto = func.properties["prototype"];
                  if (typeof proto !== "object" || proto === null) {
                    proto = this.OBJECT_PROTO;
                  }
                  state.funcThis_ = this.createObjectProto(proto);
                }
                state.isConstructor = true;
              }
              state.doneArgs_ = true;
            }
            if (!state.doneExec_) {
              state.doneExec_ = true;
              if (!(func instanceof Interpreter2.Object)) {
                this.throwException(this.TYPE_ERROR, func + " is not a function");
              }
              var funcNode = func.node;
              if (funcNode) {
                var scope = this.createScope(funcNode["body"], func.parentScope);
                for (var i = 0; i < funcNode["params"].length; i++) {
                  var paramName = funcNode["params"][i]["name"];
                  var paramValue = state.arguments_.length > i ? state.arguments_[i] : void 0;
                  this.setProperty(scope.object, paramName, paramValue);
                }
                var argsList = this.createArray();
                for (var i = 0; i < state.arguments_.length; i++) {
                  this.setProperty(argsList, i, state.arguments_[i]);
                }
                this.setProperty(scope.object, "arguments", argsList);
                var name = funcNode["id"] && funcNode["id"]["name"];
                if (name) {
                  this.setProperty(scope.object, name, func);
                }
                if (!scope.strict) {
                  state.funcThis_ = this.boxThis_(state.funcThis_);
                }
                this.setProperty(
                  scope.object,
                  "this",
                  state.funcThis_,
                  Interpreter2.READONLY_DESCRIPTOR
                );
                state.value = void 0;
                return new Interpreter2.State(funcNode["body"], scope);
              } else if (func.eval) {
                var code = state.arguments_[0];
                if (typeof code !== "string") {
                  state.value = code;
                } else {
                  try {
                    var ast = this.parse_(
                      String(code),
                      "eval" + this.evalCodeNumber_++
                    );
                  } catch (e) {
                    this.throwException(this.SYNTAX_ERROR, "Invalid code: " + e.message);
                  }
                  var evalNode = new this.newNode();
                  evalNode["type"] = "EvalProgram_";
                  evalNode["body"] = ast["body"];
                  Interpreter2.stripLocations_(evalNode, node["start"], node["end"]);
                  var scope = state.directEval_ ? state.scope : this.globalScope;
                  if (scope.strict) {
                    scope = this.createScope(ast, scope);
                  } else {
                    this.populateScope_(ast, scope);
                  }
                  this.value = void 0;
                  return new Interpreter2.State(evalNode, scope);
                }
              } else if (func.nativeFunc) {
                if (!state.scope.strict) {
                  state.funcThis_ = this.boxThis_(state.funcThis_);
                }
                state.value = func.nativeFunc.apply(state.funcThis_, state.arguments_);
              } else if (func.asyncFunc) {
                var thisInterpreter = this;
                var callback = function(value) {
                  state.value = value;
                  thisInterpreter.paused_ = false;
                };
                var argLength = func.asyncFunc.length - 1;
                var argsWithCallback = state.arguments_.concat(
                  new Array(argLength)
                ).slice(0, argLength);
                argsWithCallback.push(callback);
                this.paused_ = true;
                if (!state.scope.strict) {
                  state.funcThis_ = this.boxThis_(state.funcThis_);
                }
                func.asyncFunc.apply(state.funcThis_, argsWithCallback);
                return;
              } else {
                this.throwException(this.TYPE_ERROR, func.class + " is not callable");
              }
            } else {
              stack.pop();
              if (state.isConstructor && typeof state.value !== "object") {
                stack[stack.length - 1].value = state.funcThis_;
              } else {
                stack[stack.length - 1].value = state.value;
              }
            }
          };
          Interpreter2.prototype["stepCatchClause"] = function(stack, state, node) {
            if (!state.done_) {
              state.done_ = true;
              var scope = this.createSpecialScope(state.scope);
              this.setProperty(scope.object, node["param"]["name"], state.throwValue);
              return new Interpreter2.State(node["body"], scope);
            } else {
              stack.pop();
            }
          };
          Interpreter2.prototype["stepConditionalExpression"] = function(stack, state, node) {
            var mode = state.mode_ || 0;
            if (mode === 0) {
              state.mode_ = 1;
              return new Interpreter2.State(node["test"], state.scope);
            }
            if (mode === 1) {
              state.mode_ = 2;
              var value = Boolean(state.value);
              if (value && node["consequent"]) {
                return new Interpreter2.State(node["consequent"], state.scope);
              } else if (!value && node["alternate"]) {
                return new Interpreter2.State(node["alternate"], state.scope);
              }
              this.value = void 0;
            }
            stack.pop();
            if (node["type"] === "ConditionalExpression") {
              stack[stack.length - 1].value = state.value;
            }
          };
          Interpreter2.prototype["stepContinueStatement"] = function(stack, state, node) {
            var label = node["label"] && node["label"]["name"];
            this.unwind(Interpreter2.Completion.CONTINUE, void 0, label);
          };
          Interpreter2.prototype["stepDebuggerStatement"] = function(stack, state, node) {
            stack.pop();
          };
          Interpreter2.prototype["stepDoWhileStatement"] = function(stack, state, node) {
            if (node["type"] === "DoWhileStatement" && state.test_ === void 0) {
              state.value = true;
              state.test_ = true;
            }
            if (!state.test_) {
              state.test_ = true;
              return new Interpreter2.State(node["test"], state.scope);
            }
            if (!state.value) {
              stack.pop();
            } else if (node["body"]) {
              state.test_ = false;
              state.isLoop = true;
              return new Interpreter2.State(node["body"], state.scope);
            }
          };
          Interpreter2.prototype["stepEmptyStatement"] = function(stack, state, node) {
            stack.pop();
          };
          Interpreter2.prototype["stepEvalProgram_"] = function(stack, state, node) {
            var n = state.n_ || 0;
            var expression = node["body"][n];
            if (expression) {
              state.n_ = n + 1;
              return new Interpreter2.State(expression, state.scope);
            }
            stack.pop();
            stack[stack.length - 1].value = this.value;
          };
          Interpreter2.prototype["stepExpressionStatement"] = function(stack, state, node) {
            if (!state.done_) {
              state.done_ = true;
              return new Interpreter2.State(node["expression"], state.scope);
            }
            stack.pop();
            this.value = state.value;
          };
          Interpreter2.prototype["stepForInStatement"] = function(stack, state, node) {
            if (!state.doneInit_) {
              state.doneInit_ = true;
              if (node["left"]["declarations"] && node["left"]["declarations"][0]["init"]) {
                if (state.scope.strict) {
                  this.throwException(
                    this.SYNTAX_ERROR,
                    "for-in loop variable declaration may not have an initializer."
                  );
                }
                return new Interpreter2.State(node["left"], state.scope);
              }
            }
            if (!state.doneObject_) {
              state.doneObject_ = true;
              if (!state.variable_) {
                state.variable_ = state.value;
              }
              return new Interpreter2.State(node["right"], state.scope);
            }
            if (!state.isLoop) {
              state.isLoop = true;
              state.object_ = state.value;
              state.visited_ = /* @__PURE__ */ Object.create(null);
            }
            if (state.name_ === void 0) {
              gotPropName:
                while (true) {
                  if (state.object_ instanceof Interpreter2.Object) {
                    if (!state.props_) {
                      state.props_ = Object.getOwnPropertyNames(state.object_.properties);
                    }
                    while (true) {
                      var prop = state.props_.shift();
                      if (prop === void 0) {
                        break;
                      }
                      if (!Object.prototype.hasOwnProperty.call(
                        state.object_.properties,
                        prop
                      )) {
                        continue;
                      }
                      if (state.visited_[prop]) {
                        continue;
                      }
                      state.visited_[prop] = true;
                      if (!Object.prototype.propertyIsEnumerable.call(
                        state.object_.properties,
                        prop
                      )) {
                        continue;
                      }
                      state.name_ = prop;
                      break gotPropName;
                    }
                  } else if (state.object_ !== null && state.object_ !== void 0) {
                    if (!state.props_) {
                      state.props_ = Object.getOwnPropertyNames(state.object_);
                    }
                    while (true) {
                      var prop = state.props_.shift();
                      if (prop === void 0) {
                        break;
                      }
                      state.visited_[prop] = true;
                      if (!Object.prototype.propertyIsEnumerable.call(
                        state.object_,
                        prop
                      )) {
                        continue;
                      }
                      state.name_ = prop;
                      break gotPropName;
                    }
                  }
                  state.object_ = this.getPrototype(state.object_);
                  state.props_ = null;
                  if (state.object_ === null) {
                    stack.pop();
                    return;
                  }
                }
            }
            if (!state.doneVariable_) {
              state.doneVariable_ = true;
              var left = node["left"];
              if (left["type"] === "VariableDeclaration") {
                state.variable_ = [Interpreter2.SCOPE_REFERENCE, left["declarations"][0]["id"]["name"]];
              } else {
                state.variable_ = null;
                var nextState = new Interpreter2.State(left, state.scope);
                nextState.components = true;
                return nextState;
              }
            }
            if (!state.variable_) {
              state.variable_ = state.value;
            }
            if (!state.doneSetter_) {
              state.doneSetter_ = true;
              var value = state.name_;
              var setter = this.setValue(state.variable_, value);
              if (setter) {
                return this.createSetter_(setter, state.variable_, value);
              }
            }
            state.name_ = void 0;
            state.doneVariable_ = false;
            state.doneSetter_ = false;
            if (node["body"]) {
              return new Interpreter2.State(node["body"], state.scope);
            }
          };
          Interpreter2.prototype["stepForStatement"] = function(stack, state, node) {
            switch (state.mode_) {
              default:
                state.mode_ = 1;
                if (node["init"]) {
                  return new Interpreter2.State(node["init"], state.scope);
                }
                break;
              case 1:
                state.mode_ = 2;
                if (node["test"]) {
                  return new Interpreter2.State(node["test"], state.scope);
                }
                break;
              case 2:
                state.mode_ = 3;
                if (node["test"] && !state.value) {
                  stack.pop();
                } else {
                  state.isLoop = true;
                  return new Interpreter2.State(node["body"], state.scope);
                }
                break;
              case 3:
                state.mode_ = 1;
                if (node["update"]) {
                  return new Interpreter2.State(node["update"], state.scope);
                }
                break;
            }
          };
          Interpreter2.prototype["stepFunctionDeclaration"] = function(stack, state, node) {
            stack.pop();
          };
          Interpreter2.prototype["stepFunctionExpression"] = function(stack, state, node) {
            stack.pop();
            state = stack[stack.length - 1];
            state.value = this.createFunction(node, state.scope, state.destinationName);
          };
          Interpreter2.prototype["stepIdentifier"] = function(stack, state, node) {
            stack.pop();
            if (state.components) {
              stack[stack.length - 1].value = [Interpreter2.SCOPE_REFERENCE, node["name"]];
              return;
            }
            var value = this.getValueFromScope(node["name"]);
            if (this.getterStep_) {
              var func = value;
              return this.createGetter_(func, this.globalObject);
            }
            stack[stack.length - 1].value = value;
          };
          Interpreter2.prototype["stepIfStatement"] = Interpreter2.prototype["stepConditionalExpression"];
          Interpreter2.prototype["stepLabeledStatement"] = function(stack, state, node) {
            stack.pop();
            var labels = state.labels || [];
            labels.push(node["label"]["name"]);
            var nextState = new Interpreter2.State(node["body"], state.scope);
            nextState.labels = labels;
            return nextState;
          };
          Interpreter2.prototype["stepLiteral"] = function(stack, state, node) {
            stack.pop();
            var value = node["value"];
            if (value instanceof RegExp) {
              var pseudoRegexp = this.createObjectProto(this.REGEXP_PROTO);
              this.populateRegExp(pseudoRegexp, value);
              value = pseudoRegexp;
            }
            stack[stack.length - 1].value = value;
          };
          Interpreter2.prototype["stepLogicalExpression"] = function(stack, state, node) {
            if (node["operator"] !== "&&" && node["operator"] !== "||") {
              throw SyntaxError("Unknown logical operator: " + node["operator"]);
            }
            if (!state.doneLeft_) {
              state.doneLeft_ = true;
              return new Interpreter2.State(node["left"], state.scope);
            }
            if (!state.doneRight_) {
              if (node["operator"] === "&&" && !state.value || node["operator"] === "||" && state.value) {
                stack.pop();
                stack[stack.length - 1].value = state.value;
              } else {
                state.doneRight_ = true;
                return new Interpreter2.State(node["right"], state.scope);
              }
            } else {
              stack.pop();
              stack[stack.length - 1].value = state.value;
            }
          };
          Interpreter2.prototype["stepMemberExpression"] = function(stack, state, node) {
            if (!state.doneObject_) {
              state.doneObject_ = true;
              return new Interpreter2.State(node["object"], state.scope);
            }
            var propName;
            if (!node["computed"]) {
              state.object_ = state.value;
              propName = node["property"]["name"];
            } else if (!state.doneProperty_) {
              state.object_ = state.value;
              state.doneProperty_ = true;
              return new Interpreter2.State(node["property"], state.scope);
            } else {
              propName = state.value;
            }
            stack.pop();
            if (state.components) {
              stack[stack.length - 1].value = [state.object_, propName];
            } else {
              var value = this.getProperty(state.object_, propName);
              if (this.getterStep_) {
                var func = value;
                return this.createGetter_(func, state.object_);
              }
              stack[stack.length - 1].value = value;
            }
          };
          Interpreter2.prototype["stepNewExpression"] = Interpreter2.prototype["stepCallExpression"];
          Interpreter2.prototype["stepObjectExpression"] = function(stack, state, node) {
            var n = state.n_ || 0;
            var property = node["properties"][n];
            if (!state.object_) {
              state.object_ = this.createObjectProto(this.OBJECT_PROTO);
              state.properties_ = /* @__PURE__ */ Object.create(null);
            } else {
              var propName = state.destinationName;
              if (!state.properties_[propName]) {
                state.properties_[propName] = {};
              }
              state.properties_[propName][property["kind"]] = state.value;
              state.n_ = ++n;
              property = node["properties"][n];
            }
            if (property) {
              var key = property["key"];
              if (key["type"] === "Identifier") {
                var propName = key["name"];
              } else if (key["type"] === "Literal") {
                var propName = key["value"];
              } else {
                throw SyntaxError("Unknown object structure: " + key["type"]);
              }
              state.destinationName = propName;
              return new Interpreter2.State(property["value"], state.scope);
            }
            for (var key in state.properties_) {
              var kinds = state.properties_[key];
              if ("get" in kinds || "set" in kinds) {
                var descriptor = {
                  configurable: true,
                  enumerable: true,
                  get: kinds["get"],
                  set: kinds["set"]
                };
                this.setProperty(
                  state.object_,
                  key,
                  Interpreter2.VALUE_IN_DESCRIPTOR,
                  descriptor
                );
              } else {
                this.setProperty(state.object_, key, kinds["init"]);
              }
            }
            stack.pop();
            stack[stack.length - 1].value = state.object_;
          };
          Interpreter2.prototype["stepProgram"] = function(stack, state, node) {
            var expression = node["body"].shift();
            if (expression) {
              state.done = false;
              return new Interpreter2.State(expression, state.scope);
            }
            state.done = true;
          };
          Interpreter2.prototype["stepReturnStatement"] = function(stack, state, node) {
            if (node["argument"] && !state.done_) {
              state.done_ = true;
              return new Interpreter2.State(node["argument"], state.scope);
            }
            this.unwind(Interpreter2.Completion.RETURN, state.value, void 0);
          };
          Interpreter2.prototype["stepSequenceExpression"] = function(stack, state, node) {
            var n = state.n_ || 0;
            var expression = node["expressions"][n];
            if (expression) {
              state.n_ = n + 1;
              return new Interpreter2.State(expression, state.scope);
            }
            stack.pop();
            stack[stack.length - 1].value = state.value;
          };
          Interpreter2.prototype["stepSwitchStatement"] = function(stack, state, node) {
            if (!state.test_) {
              state.test_ = 1;
              return new Interpreter2.State(node["discriminant"], state.scope);
            }
            if (state.test_ === 1) {
              state.test_ = 2;
              state.switchValue_ = state.value;
              state.defaultCase_ = -1;
            }
            while (true) {
              var index = state.index_ || 0;
              var switchCase = node["cases"][index];
              if (!state.matched_ && switchCase && !switchCase["test"]) {
                state.defaultCase_ = index;
                state.index_ = index + 1;
                continue;
              }
              if (!switchCase && !state.matched_ && state.defaultCase_ !== -1) {
                state.matched_ = true;
                state.index_ = state.defaultCase_;
                continue;
              }
              if (switchCase) {
                if (!state.matched_ && !state.tested_ && switchCase["test"]) {
                  state.tested_ = true;
                  return new Interpreter2.State(switchCase["test"], state.scope);
                }
                if (state.matched_ || state.value === state.switchValue_) {
                  state.matched_ = true;
                  var n = state.n_ || 0;
                  if (switchCase["consequent"][n]) {
                    state.isSwitch = true;
                    state.n_ = n + 1;
                    return new Interpreter2.State(
                      switchCase["consequent"][n],
                      state.scope
                    );
                  }
                }
                state.tested_ = false;
                state.n_ = 0;
                state.index_ = index + 1;
              } else {
                stack.pop();
                return;
              }
            }
          };
          Interpreter2.prototype["stepThisExpression"] = function(stack, state, node) {
            stack.pop();
            stack[stack.length - 1].value = this.getValueFromScope("this");
          };
          Interpreter2.prototype["stepThrowStatement"] = function(stack, state, node) {
            if (!state.done_) {
              state.done_ = true;
              return new Interpreter2.State(node["argument"], state.scope);
            } else {
              this.throwException(state.value);
            }
          };
          Interpreter2.prototype["stepTryStatement"] = function(stack, state, node) {
            if (!state.doneBlock_) {
              state.doneBlock_ = true;
              return new Interpreter2.State(node["block"], state.scope);
            }
            if (state.cv && state.cv.type === Interpreter2.Completion.THROW && !state.doneHandler_ && node["handler"]) {
              state.doneHandler_ = true;
              var nextState = new Interpreter2.State(node["handler"], state.scope);
              nextState.throwValue = state.cv.value;
              state.cv = void 0;
              return nextState;
            }
            if (!state.doneFinalizer_ && node["finalizer"]) {
              state.doneFinalizer_ = true;
              return new Interpreter2.State(node["finalizer"], state.scope);
            }
            stack.pop();
            if (state.cv) {
              this.unwind(state.cv.type, state.cv.value, state.cv.label);
            }
          };
          Interpreter2.prototype["stepUnaryExpression"] = function(stack, state, node) {
            if (!state.done_) {
              state.done_ = true;
              var nextState = new Interpreter2.State(node["argument"], state.scope);
              nextState.components = node["operator"] === "delete";
              return nextState;
            }
            stack.pop();
            var value = state.value;
            switch (node["operator"]) {
              case "-":
                value = -value;
                break;
              case "+":
                value = +value;
                break;
              case "!":
                value = !value;
                break;
              case "~":
                value = ~value;
                break;
              case "delete":
                var result = true;
                if (Array.isArray(value)) {
                  var obj = value[0];
                  if (obj === Interpreter2.SCOPE_REFERENCE) {
                    obj = state.scope;
                  }
                  var name = String(value[1]);
                  try {
                    delete obj.properties[name];
                  } catch (_e) {
                    if (state.scope.strict) {
                      this.throwException(this.TYPE_ERROR, "Cannot delete property '" + name + "' of '" + obj + "'");
                    } else {
                      result = false;
                    }
                  }
                }
                value = result;
                break;
              case "typeof":
                value = value && value.class === "Function" ? "function" : typeof value;
                break;
              case "void":
                value = void 0;
                break;
              default:
                throw SyntaxError("Unknown unary operator: " + node["operator"]);
            }
            stack[stack.length - 1].value = value;
          };
          Interpreter2.prototype["stepUpdateExpression"] = function(stack, state, node) {
            if (!state.doneLeft_) {
              state.doneLeft_ = true;
              var nextState = new Interpreter2.State(node["argument"], state.scope);
              nextState.components = true;
              return nextState;
            }
            if (!state.leftSide_) {
              state.leftSide_ = state.value;
            }
            if (state.doneGetter_) {
              state.leftValue_ = state.value;
            }
            if (!state.doneGetter_) {
              var leftValue = this.getValue(state.leftSide_);
              state.leftValue_ = leftValue;
              if (this.getterStep_) {
                state.doneGetter_ = true;
                var func = leftValue;
                return this.createGetter_(func, state.leftSide_);
              }
            }
            if (state.doneSetter_) {
              stack.pop();
              stack[stack.length - 1].value = state.setterValue_;
              return;
            }
            var leftValue = Number(state.leftValue_);
            var changeValue;
            if (node["operator"] === "++") {
              changeValue = leftValue + 1;
            } else if (node["operator"] === "--") {
              changeValue = leftValue - 1;
            } else {
              throw SyntaxError("Unknown update expression: " + node["operator"]);
            }
            var returnValue = node["prefix"] ? changeValue : leftValue;
            var setter = this.setValue(state.leftSide_, changeValue);
            if (setter) {
              state.doneSetter_ = true;
              state.setterValue_ = returnValue;
              return this.createSetter_(setter, state.leftSide_, changeValue);
            }
            stack.pop();
            stack[stack.length - 1].value = returnValue;
          };
          Interpreter2.prototype["stepVariableDeclaration"] = function(stack, state, node) {
            var declarations = node["declarations"];
            var n = state.n_ || 0;
            var declarationNode = declarations[n];
            if (state.init_ && declarationNode) {
              this.setValueToScope(declarationNode["id"]["name"], state.value);
              state.init_ = false;
              declarationNode = declarations[++n];
            }
            while (declarationNode) {
              if (declarationNode["init"]) {
                state.n_ = n;
                state.init_ = true;
                state.destinationName = declarationNode["id"]["name"];
                return new Interpreter2.State(declarationNode["init"], state.scope);
              }
              declarationNode = declarations[++n];
            }
            stack.pop();
          };
          Interpreter2.prototype["stepWithStatement"] = function(stack, state, node) {
            if (!state.doneObject_) {
              state.doneObject_ = true;
              return new Interpreter2.State(node["object"], state.scope);
            } else if (!state.doneBody_) {
              state.doneBody_ = true;
              var scope = this.createSpecialScope(state.scope, state.value);
              return new Interpreter2.State(node["body"], scope);
            } else {
              stack.pop();
            }
          };
          Interpreter2.prototype["stepWhileStatement"] = Interpreter2.prototype["stepDoWhileStatement"];
          Interpreter2.nativeGlobal["Interpreter"] = Interpreter2;
          Interpreter2.prototype["step"] = Interpreter2.prototype.step;
          Interpreter2.prototype["run"] = Interpreter2.prototype.run;
          Interpreter2.prototype["appendCode"] = Interpreter2.prototype.appendCode;
          Interpreter2.prototype["createObject"] = Interpreter2.prototype.createObject;
          Interpreter2.prototype["createObjectProto"] = Interpreter2.prototype.createObjectProto;
          Interpreter2.prototype["createAsyncFunction"] = Interpreter2.prototype.createAsyncFunction;
          Interpreter2.prototype["createNativeFunction"] = Interpreter2.prototype.createNativeFunction;
          Interpreter2.prototype["getProperty"] = Interpreter2.prototype.getProperty;
          Interpreter2.prototype["setProperty"] = Interpreter2.prototype.setProperty;
          Interpreter2.prototype["nativeToPseudo"] = Interpreter2.prototype.nativeToPseudo;
          Interpreter2.prototype["pseudoToNative"] = Interpreter2.prototype.pseudoToNative;
          Interpreter2.prototype["getGlobalScope"] = Interpreter2.prototype.getGlobalScope;
          Interpreter2.prototype["getStateStack"] = Interpreter2.prototype.getStateStack;
          Interpreter2.prototype["setStateStack"] = Interpreter2.prototype.setStateStack;
          Interpreter2["VALUE_IN_DESCRIPTOR"] = Interpreter2.VALUE_IN_DESCRIPTOR;
          module2.exports = {
            Interpreter: Interpreter2
          };
        },
        "./original-repo/acorn.js": function(module2, exports2) {
          (function(root, mod) {
            return mod(exports2);
          })(this, function(exports3) {
            exports3.version = "0.5.0";
            var options, input, inputLen, sourceFile;
            exports3.parse = function(inpt, opts) {
              input = String(inpt);
              inputLen = input.length;
              setOptions(opts);
              initTokenState();
              return parseTopLevel(options.program);
            };
            var defaultOptions = exports3.defaultOptions = {
              strictSemicolons: false,
              allowTrailingCommas: true,
              forbidReserved: false,
              allowReturnOutsideFunction: false,
              locations: false,
              onComment: null,
              ranges: false,
              program: null,
              sourceFile: null,
              directSourceFile: null
            };
            function setOptions(opts) {
              options = opts || {};
              for (var opt in defaultOptions)
                if (!Object.prototype.hasOwnProperty.call(options, opt))
                  options[opt] = defaultOptions[opt];
              sourceFile = options.sourceFile || null;
            }
            var getLineInfo = exports3.getLineInfo = function(input2, offset) {
              for (var line = 1, cur = 0; ; ) {
                lineBreak.lastIndex = cur;
                var match = lineBreak.exec(input2);
                if (match && match.index < offset) {
                  ++line;
                  cur = match.index + match[0].length;
                } else
                  break;
              }
              return { line, column: offset - cur };
            };
            exports3.tokenize = function(inpt, opts) {
              input = String(inpt);
              inputLen = input.length;
              setOptions(opts);
              initTokenState();
              var t = {};
              function getToken(forceRegexp) {
                lastEnd = tokEnd;
                readToken(forceRegexp);
                t.start = tokStart;
                t.end = tokEnd;
                t.startLoc = tokStartLoc;
                t.endLoc = tokEndLoc;
                t.type = tokType;
                t.value = tokVal;
                return t;
              }
              getToken.jumpTo = function(pos, reAllowed) {
                tokPos = pos;
                if (options.locations) {
                  tokCurLine = 1;
                  tokLineStart = lineBreak.lastIndex = 0;
                  var match;
                  while ((match = lineBreak.exec(input)) && match.index < pos) {
                    ++tokCurLine;
                    tokLineStart = match.index + match[0].length;
                  }
                }
                tokRegexpAllowed = reAllowed;
                skipSpace();
              };
              return getToken;
            };
            var tokPos;
            var tokStart, tokEnd;
            var tokStartLoc, tokEndLoc;
            var tokType, tokVal;
            var tokRegexpAllowed;
            var tokCurLine, tokLineStart;
            var lastStart, lastEnd, lastEndLoc;
            var inFunction, labels, strict;
            function raise(pos, message) {
              var loc = getLineInfo(input, pos);
              message += " (" + loc.line + ":" + loc.column + ")";
              var err = new SyntaxError(message);
              err.pos = pos;
              err.loc = loc;
              err.raisedAt = tokPos;
              throw err;
            }
            var empty = [];
            var _num = { type: "num" }, _regexp = { type: "regexp" }, _string = { type: "string" };
            var _name = { type: "name" }, _eof = { type: "eof" };
            var _break = { keyword: "break" }, _case = { keyword: "case", beforeExpr: true }, _catch = { keyword: "catch" };
            var _continue = { keyword: "continue" }, _debugger = { keyword: "debugger" }, _default = { keyword: "default" };
            var _do = { keyword: "do", isLoop: true }, _else = { keyword: "else", beforeExpr: true };
            var _finally = { keyword: "finally" }, _for = { keyword: "for", isLoop: true }, _function = { keyword: "function" };
            var _if = { keyword: "if" }, _return = { keyword: "return", beforeExpr: true }, _switch = { keyword: "switch" };
            var _throw = { keyword: "throw", beforeExpr: true }, _try = { keyword: "try" }, _var = { keyword: "var" };
            var _while = { keyword: "while", isLoop: true }, _with = { keyword: "with" }, _new = { keyword: "new", beforeExpr: true };
            var _this = { keyword: "this" };
            var _null = { keyword: "null", atomValue: null }, _true = { keyword: "true", atomValue: true };
            var _false = { keyword: "false", atomValue: false };
            var _in = { keyword: "in", binop: 7, beforeExpr: true };
            var keywordTypes = {
              "break": _break,
              "case": _case,
              "catch": _catch,
              "continue": _continue,
              "debugger": _debugger,
              "default": _default,
              "do": _do,
              "else": _else,
              "finally": _finally,
              "for": _for,
              "function": _function,
              "if": _if,
              "return": _return,
              "switch": _switch,
              "throw": _throw,
              "try": _try,
              "var": _var,
              "while": _while,
              "with": _with,
              "null": _null,
              "true": _true,
              "false": _false,
              "new": _new,
              "in": _in,
              "instanceof": { keyword: "instanceof", binop: 7, beforeExpr: true },
              "this": _this,
              "typeof": { keyword: "typeof", prefix: true, beforeExpr: true },
              "void": { keyword: "void", prefix: true, beforeExpr: true },
              "delete": { keyword: "delete", prefix: true, beforeExpr: true }
            };
            var _bracketL = { type: "[", beforeExpr: true }, _bracketR = { type: "]" }, _braceL = { type: "{", beforeExpr: true };
            var _braceR = { type: "}" }, _parenL = { type: "(", beforeExpr: true }, _parenR = { type: ")" };
            var _comma = { type: ",", beforeExpr: true }, _semi = { type: ";", beforeExpr: true };
            var _colon = { type: ":", beforeExpr: true }, _dot = { type: "." }, _question = { type: "?", beforeExpr: true };
            var _slash = { binop: 10, beforeExpr: true }, _eq = { isAssign: true, beforeExpr: true };
            var _assign = { isAssign: true, beforeExpr: true };
            var _incDec = { postfix: true, prefix: true, isUpdate: true }, _prefix = { prefix: true, beforeExpr: true };
            var _logicalOR = { binop: 1, beforeExpr: true };
            var _logicalAND = { binop: 2, beforeExpr: true };
            var _bitwiseOR = { binop: 3, beforeExpr: true };
            var _bitwiseXOR = { binop: 4, beforeExpr: true };
            var _bitwiseAND = { binop: 5, beforeExpr: true };
            var _equality = { binop: 6, beforeExpr: true };
            var _relational = { binop: 7, beforeExpr: true };
            var _bitShift = { binop: 8, beforeExpr: true };
            var _plusMin = { binop: 9, prefix: true, beforeExpr: true };
            var _multiplyModulo = { binop: 10, beforeExpr: true };
            exports3.tokTypes = {
              bracketL: _bracketL,
              bracketR: _bracketR,
              braceL: _braceL,
              braceR: _braceR,
              parenL: _parenL,
              parenR: _parenR,
              comma: _comma,
              semi: _semi,
              colon: _colon,
              dot: _dot,
              question: _question,
              slash: _slash,
              eq: _eq,
              name: _name,
              eof: _eof,
              num: _num,
              regexp: _regexp,
              string: _string
            };
            for (var kw in keywordTypes)
              exports3.tokTypes["_" + kw] = keywordTypes[kw];
            function makePredicate(words) {
              words = words.split(" ");
              var set2 = /* @__PURE__ */ Object.create(null);
              for (var i = 0; i < words.length; i++) {
                set2[words[i]] = true;
              }
              return function(str) {
                return set2[str] || false;
              };
            }
            var isReservedWord5 = makePredicate("class enum extends super const export import");
            var isStrictReservedWord = makePredicate("implements interface let package private protected public static yield");
            var isStrictBadIdWord = makePredicate("eval arguments");
            var isKeyword = makePredicate("break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this");
            var nonASCIIwhitespace = /[\u1680\u180e\u2000-\u200a\u202f\u205f\u3000\ufeff]/;
            var nonASCIIidentifierStartChars = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0527\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0\u08A2-\u08AC\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0977\u0979-\u097F\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D\u0C58\u0C59\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D60\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F0\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191C\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19C1-\u19C7\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FCC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA697\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA78E\uA790-\uA793\uA7A0-\uA7AA\uA7F8-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA80-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC";
            var nonASCIIidentifierChars = "\u0300-\u036F\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u0620-\u0649\u0672-\u06D3\u06E7-\u06E8\u06FB-\u06FC\u0730-\u074A\u0800-\u0814\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0840-\u0857\u08E4-\u08FE\u0900-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962-\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09D7\u09DF-\u09E0\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2-\u0AE3\u0AE6-\u0AEF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5F-\u0B60\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C01-\u0C03\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62-\u0C63\u0C66-\u0C6F\u0C82\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2-\u0CE3\u0CE6-\u0CEF\u0D02\u0D03\u0D46-\u0D48\u0D57\u0D62-\u0D63\u0D66-\u0D6F\u0D82\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DF2\u0DF3\u0E34-\u0E3A\u0E40-\u0E45\u0E50-\u0E59\u0EB4-\u0EB9\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F41-\u0F47\u0F71-\u0F84\u0F86-\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1029\u1040-\u1049\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u170E-\u1710\u1720-\u1730\u1740-\u1750\u1772\u1773\u1780-\u17B2\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1920-\u192B\u1930-\u193B\u1951-\u196D\u19B0-\u19C0\u19C8-\u19C9\u19D0-\u19D9\u1A00-\u1A15\u1A20-\u1A53\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1B46-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C00-\u1C22\u1C40-\u1C49\u1C5B-\u1C7D\u1CD0-\u1CD2\u1D00-\u1DBE\u1E01-\u1F15\u200C\u200D\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2D81-\u2D96\u2DE0-\u2DFF\u3021-\u3028\u3099\u309A\uA640-\uA66D\uA674-\uA67D\uA69F\uA6F0-\uA6F1\uA7F8-\uA800\uA806\uA80B\uA823-\uA827\uA880-\uA881\uA8B4-\uA8C4\uA8D0-\uA8D9\uA8F3-\uA8F7\uA900-\uA909\uA926-\uA92D\uA930-\uA945\uA980-\uA983\uA9B3-\uA9C0\uAA00-\uAA27\uAA40-\uAA41\uAA4C-\uAA4D\uAA50-\uAA59\uAA7B\uAAE0-\uAAE9\uAAF2-\uAAF3\uABC0-\uABE1\uABEC\uABED\uABF0-\uABF9\uFB20-\uFB28\uFE00-\uFE0F\uFE20-\uFE26\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F";
            var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
            var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
            var newline = /[\n\r\u2028\u2029]/;
            var lineBreak = /\r\n|[\n\r\u2028\u2029]/g;
            var isIdentifierStart = exports3.isIdentifierStart = function(code) {
              if (code < 65)
                return code === 36;
              if (code < 91)
                return true;
              if (code < 97)
                return code === 95;
              if (code < 123)
                return true;
              return code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code));
            };
            var isIdentifierChar = exports3.isIdentifierChar = function(code) {
              if (code < 48)
                return code === 36;
              if (code < 58)
                return true;
              if (code < 65)
                return false;
              if (code < 91)
                return true;
              if (code < 97)
                return code === 95;
              if (code < 123)
                return true;
              return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
            };
            function line_loc_t() {
              this.line = tokCurLine;
              this.column = tokPos - tokLineStart;
            }
            function initTokenState() {
              tokCurLine = 1;
              tokPos = tokLineStart = 0;
              tokRegexpAllowed = true;
              skipSpace();
            }
            function finishToken(type, val) {
              tokEnd = tokPos;
              if (options.locations)
                tokEndLoc = new line_loc_t();
              tokType = type;
              skipSpace();
              tokVal = val;
              tokRegexpAllowed = type.beforeExpr;
            }
            function skipBlockComment() {
              var startLoc = options.onComment && options.locations && new line_loc_t();
              var start = tokPos, end = input.indexOf("*/", tokPos += 2);
              if (end === -1)
                raise(tokPos - 2, "Unterminated comment");
              tokPos = end + 2;
              if (options.locations) {
                lineBreak.lastIndex = start;
                var match;
                while ((match = lineBreak.exec(input)) && match.index < tokPos) {
                  ++tokCurLine;
                  tokLineStart = match.index + match[0].length;
                }
              }
              if (options.onComment)
                options.onComment(
                  true,
                  input.slice(start + 2, end),
                  start,
                  tokPos,
                  startLoc,
                  options.locations && new line_loc_t()
                );
            }
            function skipLineComment() {
              var start = tokPos;
              var startLoc = options.onComment && options.locations && new line_loc_t();
              var ch = input.charCodeAt(tokPos += 2);
              while (tokPos < inputLen && ch !== 10 && ch !== 13 && ch !== 8232 && ch !== 8233) {
                ++tokPos;
                ch = input.charCodeAt(tokPos);
              }
              if (options.onComment)
                options.onComment(
                  false,
                  input.slice(start + 2, tokPos),
                  start,
                  tokPos,
                  startLoc,
                  options.locations && new line_loc_t()
                );
            }
            function skipSpace() {
              while (tokPos < inputLen) {
                var ch = input.charCodeAt(tokPos);
                if (ch === 32) {
                  ++tokPos;
                } else if (ch === 13) {
                  ++tokPos;
                  var next2 = input.charCodeAt(tokPos);
                  if (next2 === 10) {
                    ++tokPos;
                  }
                  if (options.locations) {
                    ++tokCurLine;
                    tokLineStart = tokPos;
                  }
                } else if (ch === 10 || ch === 8232 || ch === 8233) {
                  ++tokPos;
                  if (options.locations) {
                    ++tokCurLine;
                    tokLineStart = tokPos;
                  }
                } else if (ch > 8 && ch < 14) {
                  ++tokPos;
                } else if (ch === 47) {
                  var next2 = input.charCodeAt(tokPos + 1);
                  if (next2 === 42) {
                    skipBlockComment();
                  } else if (next2 === 47) {
                    skipLineComment();
                  } else
                    break;
                } else if (ch === 160) {
                  ++tokPos;
                } else if (ch >= 5760 && nonASCIIwhitespace.test(String.fromCharCode(ch))) {
                  ++tokPos;
                } else {
                  break;
                }
              }
            }
            function readToken_dot() {
              var next2 = input.charCodeAt(tokPos + 1);
              if (next2 >= 48 && next2 <= 57)
                return readNumber(true);
              ++tokPos;
              return finishToken(_dot);
            }
            function readToken_slash() {
              var next2 = input.charCodeAt(tokPos + 1);
              if (tokRegexpAllowed) {
                ++tokPos;
                return readRegexp();
              }
              if (next2 === 61)
                return finishOp(_assign, 2);
              return finishOp(_slash, 1);
            }
            function readToken_mult_modulo() {
              var next2 = input.charCodeAt(tokPos + 1);
              if (next2 === 61)
                return finishOp(_assign, 2);
              return finishOp(_multiplyModulo, 1);
            }
            function readToken_pipe_amp(code) {
              var next2 = input.charCodeAt(tokPos + 1);
              if (next2 === code)
                return finishOp(code === 124 ? _logicalOR : _logicalAND, 2);
              if (next2 === 61)
                return finishOp(_assign, 2);
              return finishOp(code === 124 ? _bitwiseOR : _bitwiseAND, 1);
            }
            function readToken_caret() {
              var next2 = input.charCodeAt(tokPos + 1);
              if (next2 === 61)
                return finishOp(_assign, 2);
              return finishOp(_bitwiseXOR, 1);
            }
            function readToken_plus_min(code) {
              var next2 = input.charCodeAt(tokPos + 1);
              if (next2 === code) {
                if (next2 == 45 && input.charCodeAt(tokPos + 2) == 62 && newline.test(input.slice(lastEnd, tokPos))) {
                  tokPos += 3;
                  skipLineComment();
                  skipSpace();
                  return readToken();
                }
                return finishOp(_incDec, 2);
              }
              if (next2 === 61)
                return finishOp(_assign, 2);
              return finishOp(_plusMin, 1);
            }
            function readToken_lt_gt(code) {
              var next2 = input.charCodeAt(tokPos + 1);
              var size = 1;
              if (next2 === code) {
                size = code === 62 && input.charCodeAt(tokPos + 2) === 62 ? 3 : 2;
                if (input.charCodeAt(tokPos + size) === 61)
                  return finishOp(_assign, size + 1);
                return finishOp(_bitShift, size);
              }
              if (next2 == 33 && code == 60 && input.charCodeAt(tokPos + 2) == 45 && input.charCodeAt(tokPos + 3) == 45) {
                tokPos += 4;
                skipLineComment();
                skipSpace();
                return readToken();
              }
              if (next2 === 61)
                size = input.charCodeAt(tokPos + 2) === 61 ? 3 : 2;
              return finishOp(_relational, size);
            }
            function readToken_eq_excl(code) {
              var next2 = input.charCodeAt(tokPos + 1);
              if (next2 === 61)
                return finishOp(_equality, input.charCodeAt(tokPos + 2) === 61 ? 3 : 2);
              return finishOp(code === 61 ? _eq : _prefix, 1);
            }
            function getTokenFromCode(code) {
              switch (code) {
                case 46:
                  return readToken_dot();
                case 40:
                  ++tokPos;
                  return finishToken(_parenL);
                case 41:
                  ++tokPos;
                  return finishToken(_parenR);
                case 59:
                  ++tokPos;
                  return finishToken(_semi);
                case 44:
                  ++tokPos;
                  return finishToken(_comma);
                case 91:
                  ++tokPos;
                  return finishToken(_bracketL);
                case 93:
                  ++tokPos;
                  return finishToken(_bracketR);
                case 123:
                  ++tokPos;
                  return finishToken(_braceL);
                case 125:
                  ++tokPos;
                  return finishToken(_braceR);
                case 58:
                  ++tokPos;
                  return finishToken(_colon);
                case 63:
                  ++tokPos;
                  return finishToken(_question);
                case 48:
                  var next2 = input.charCodeAt(tokPos + 1);
                  if (next2 === 120 || next2 === 88)
                    return readHexNumber();
                case 49:
                case 50:
                case 51:
                case 52:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                  return readNumber(false);
                case 34:
                case 39:
                  return readString(code);
                case 47:
                  return readToken_slash();
                case 37:
                case 42:
                  return readToken_mult_modulo();
                case 124:
                case 38:
                  return readToken_pipe_amp(code);
                case 94:
                  return readToken_caret();
                case 43:
                case 45:
                  return readToken_plus_min(code);
                case 60:
                case 62:
                  return readToken_lt_gt(code);
                case 61:
                case 33:
                  return readToken_eq_excl(code);
                case 126:
                  return finishOp(_prefix, 1);
              }
              return false;
            }
            function readToken(forceRegexp) {
              if (!forceRegexp)
                tokStart = tokPos;
              else
                tokPos = tokStart + 1;
              if (options.locations)
                tokStartLoc = new line_loc_t();
              if (forceRegexp)
                return readRegexp();
              if (tokPos >= inputLen)
                return finishToken(_eof);
              var code = input.charCodeAt(tokPos);
              if (isIdentifierStart(code) || code === 92)
                return readWord();
              var tok = getTokenFromCode(code);
              if (tok === false) {
                var ch = String.fromCharCode(code);
                if (ch === "\\" || nonASCIIidentifierStart.test(ch))
                  return readWord();
                raise(tokPos, "Unexpected character '" + ch + "'");
              }
              return tok;
            }
            function finishOp(type, size) {
              var str = input.slice(tokPos, tokPos + size);
              tokPos += size;
              finishToken(type, str);
            }
            function readRegexp() {
              var escaped, inClass, start = tokPos;
              for (; ; ) {
                if (tokPos >= inputLen)
                  raise(start, "Unterminated regular expression");
                var ch = input.charAt(tokPos);
                if (newline.test(ch))
                  raise(start, "Unterminated regular expression");
                if (!escaped) {
                  if (ch === "[")
                    inClass = true;
                  else if (ch === "]" && inClass)
                    inClass = false;
                  else if (ch === "/" && !inClass)
                    break;
                  escaped = ch === "\\";
                } else
                  escaped = false;
                ++tokPos;
              }
              var content = input.slice(start, tokPos);
              ++tokPos;
              var mods = readWord1();
              if (mods && !/^[gmi]*$/.test(mods))
                raise(start, "Invalid regexp flag");
              try {
                var value = new RegExp(content, mods);
              } catch (e) {
                if (e instanceof SyntaxError)
                  raise(start, e.message);
                raise(e);
              }
              return finishToken(_regexp, value);
            }
            function readInt(radix, len) {
              var start = tokPos, total = 0;
              for (var i = 0, e = len == null ? Infinity : len; i < e; ++i) {
                var code = input.charCodeAt(tokPos), val;
                if (code >= 97)
                  val = code - 97 + 10;
                else if (code >= 65)
                  val = code - 65 + 10;
                else if (code >= 48 && code <= 57)
                  val = code - 48;
                else
                  val = Infinity;
                if (val >= radix)
                  break;
                ++tokPos;
                total = total * radix + val;
              }
              if (tokPos === start || len != null && tokPos - start !== len)
                return null;
              return total;
            }
            function readHexNumber() {
              tokPos += 2;
              var val = readInt(16);
              if (val == null)
                raise(tokStart + 2, "Expected hexadecimal number");
              if (isIdentifierStart(input.charCodeAt(tokPos)))
                raise(tokPos, "Identifier directly after number");
              return finishToken(_num, val);
            }
            function readNumber(startsWithDot) {
              var start = tokPos, isFloat = false, octal = input.charCodeAt(tokPos) === 48;
              if (!startsWithDot && readInt(10) === null)
                raise(start, "Invalid number");
              if (input.charCodeAt(tokPos) === 46) {
                ++tokPos;
                readInt(10);
                isFloat = true;
              }
              var next2 = input.charCodeAt(tokPos);
              if (next2 === 69 || next2 === 101) {
                next2 = input.charCodeAt(++tokPos);
                if (next2 === 43 || next2 === 45)
                  ++tokPos;
                if (readInt(10) === null)
                  raise(start, "Invalid number");
                isFloat = true;
              }
              if (isIdentifierStart(input.charCodeAt(tokPos)))
                raise(tokPos, "Identifier directly after number");
              var str = input.slice(start, tokPos), val;
              if (isFloat)
                val = parseFloat(str);
              else if (!octal || str.length === 1)
                val = parseInt(str, 10);
              else if (/[89]/.test(str) || strict)
                raise(start, "Invalid number");
              else
                val = parseInt(str, 8);
              return finishToken(_num, val);
            }
            function readString(quote) {
              tokPos++;
              var out = "";
              for (; ; ) {
                if (tokPos >= inputLen)
                  raise(tokStart, "Unterminated string constant");
                var ch = input.charCodeAt(tokPos);
                if (ch === quote) {
                  ++tokPos;
                  return finishToken(_string, out);
                }
                if (ch === 92) {
                  ch = input.charCodeAt(++tokPos);
                  var octal = /^[0-7]+/.exec(input.slice(tokPos, tokPos + 3));
                  if (octal)
                    octal = octal[0];
                  while (octal && parseInt(octal, 8) > 255)
                    octal = octal.slice(0, -1);
                  if (octal === "0")
                    octal = null;
                  ++tokPos;
                  if (octal) {
                    if (strict)
                      raise(tokPos - 2, "Octal literal in strict mode");
                    out += String.fromCharCode(parseInt(octal, 8));
                    tokPos += octal.length - 1;
                  } else {
                    switch (ch) {
                      case 110:
                        out += "\n";
                        break;
                      case 114:
                        out += "\r";
                        break;
                      case 120:
                        out += String.fromCharCode(readHexChar(2));
                        break;
                      case 117:
                        out += String.fromCharCode(readHexChar(4));
                        break;
                      case 85:
                        out += String.fromCharCode(readHexChar(8));
                        break;
                      case 116:
                        out += "	";
                        break;
                      case 98:
                        out += "\b";
                        break;
                      case 118:
                        out += "\v";
                        break;
                      case 102:
                        out += "\f";
                        break;
                      case 48:
                        out += "\0";
                        break;
                      case 13:
                        if (input.charCodeAt(tokPos) === 10)
                          ++tokPos;
                      case 10:
                        if (options.locations) {
                          tokLineStart = tokPos;
                          ++tokCurLine;
                        }
                        break;
                      default:
                        out += String.fromCharCode(ch);
                        break;
                    }
                  }
                } else {
                  if (ch === 13 || ch === 10 || ch === 8232 || ch === 8233)
                    raise(tokStart, "Unterminated string constant");
                  out += String.fromCharCode(ch);
                  ++tokPos;
                }
              }
            }
            function readHexChar(len) {
              var n = readInt(16, len);
              if (n === null)
                raise(tokStart, "Bad character escape sequence");
              return n;
            }
            var containsEsc;
            function readWord1() {
              containsEsc = false;
              var word, first = true, start = tokPos;
              for (; ; ) {
                var ch = input.charCodeAt(tokPos);
                if (isIdentifierChar(ch)) {
                  if (containsEsc)
                    word += input.charAt(tokPos);
                  ++tokPos;
                } else if (ch === 92) {
                  if (!containsEsc)
                    word = input.slice(start, tokPos);
                  containsEsc = true;
                  if (input.charCodeAt(++tokPos) != 117)
                    raise(tokPos, "Expecting Unicode escape sequence \\uXXXX");
                  ++tokPos;
                  var esc = readHexChar(4);
                  var escStr = String.fromCharCode(esc);
                  if (!escStr)
                    raise(tokPos - 1, "Invalid Unicode escape");
                  if (!(first ? isIdentifierStart(esc) : isIdentifierChar(esc)))
                    raise(tokPos - 4, "Invalid Unicode escape");
                  word += escStr;
                } else {
                  break;
                }
                first = false;
              }
              return containsEsc ? word : input.slice(start, tokPos);
            }
            function readWord() {
              var word = readWord1();
              var type = _name;
              if (!containsEsc && isKeyword(word))
                type = keywordTypes[word];
              return finishToken(type, word);
            }
            function next() {
              lastStart = tokStart;
              lastEnd = tokEnd;
              lastEndLoc = tokEndLoc;
              readToken();
            }
            function setStrict(strct) {
              strict = strct;
              tokPos = tokStart;
              if (options.locations) {
                while (tokPos < tokLineStart) {
                  tokLineStart = input.lastIndexOf("\n", tokLineStart - 2) + 1;
                  --tokCurLine;
                }
              }
              skipSpace();
              readToken();
            }
            function node_t() {
              this.type = null;
              this.start = tokStart;
              this.end = null;
            }
            function node_loc_t() {
              this.start = tokStartLoc;
              this.end = null;
              if (sourceFile !== null)
                this.source = sourceFile;
            }
            function startNode() {
              var node = new node_t();
              if (options.locations)
                node.loc = new node_loc_t();
              if (options.directSourceFile)
                node.sourceFile = options.directSourceFile;
              if (options.ranges)
                node.range = [tokStart, 0];
              return node;
            }
            function startNodeFrom(other) {
              var node = new node_t();
              node.start = other.start;
              if (options.locations) {
                node.loc = new node_loc_t();
                node.loc.start = other.loc.start;
              }
              if (options.ranges)
                node.range = [other.range[0], 0];
              return node;
            }
            function finishNode(node, type) {
              node.type = type;
              node.end = lastEnd;
              if (options.locations)
                node.loc.end = lastEndLoc;
              if (options.ranges)
                node.range[1] = lastEnd;
              return node;
            }
            function isUseStrict(stmt) {
              return stmt.type === "ExpressionStatement" && stmt.expression.type === "Literal" && stmt.expression.value === "use strict";
            }
            function eat(type) {
              if (tokType === type) {
                next();
                return true;
              }
            }
            function canInsertSemicolon() {
              return !options.strictSemicolons && (tokType === _eof || tokType === _braceR || newline.test(input.slice(lastEnd, tokStart)));
            }
            function semicolon() {
              if (!eat(_semi) && !canInsertSemicolon())
                unexpected();
            }
            function expect(type) {
              if (tokType === type)
                next();
              else
                unexpected();
            }
            function unexpected() {
              raise(tokStart, "Unexpected token");
            }
            function checkLVal(expr) {
              if (expr.type !== "Identifier" && expr.type !== "MemberExpression")
                raise(expr.start, "Assigning to rvalue");
              if (strict && expr.type === "Identifier" && isStrictBadIdWord(expr.name))
                raise(expr.start, "Assigning to " + expr.name + " in strict mode");
            }
            function parseTopLevel(program) {
              lastStart = lastEnd = tokPos;
              if (options.locations)
                lastEndLoc = new line_loc_t();
              inFunction = strict = null;
              labels = [];
              readToken();
              var node = program || startNode(), first = true;
              if (!program)
                node.body = [];
              while (tokType !== _eof) {
                var stmt = parseStatement();
                node.body.push(stmt);
                if (first && isUseStrict(stmt))
                  setStrict(true);
                first = false;
              }
              return finishNode(node, "Program");
            }
            var loopLabel = { kind: "loop" }, switchLabel = { kind: "switch" };
            function parseStatement() {
              if (tokType === _slash || tokType === _assign && tokVal == "/=")
                readToken(true);
              var starttype = tokType, node = startNode();
              switch (starttype) {
                case _break:
                case _continue:
                  next();
                  var isBreak = starttype === _break;
                  if (eat(_semi) || canInsertSemicolon())
                    node.label = null;
                  else if (tokType !== _name)
                    unexpected();
                  else {
                    node.label = parseIdent();
                    semicolon();
                  }
                  for (var i = 0; i < labels.length; ++i) {
                    var lab = labels[i];
                    if (node.label == null || lab.name === node.label.name) {
                      if (lab.kind != null && (isBreak || lab.kind === "loop"))
                        break;
                      if (node.label && isBreak)
                        break;
                    }
                  }
                  if (i === labels.length)
                    raise(node.start, "Unsyntactic " + starttype.keyword);
                  return finishNode(node, isBreak ? "BreakStatement" : "ContinueStatement");
                case _debugger:
                  next();
                  semicolon();
                  return finishNode(node, "DebuggerStatement");
                case _do:
                  next();
                  labels.push(loopLabel);
                  node.body = parseStatement();
                  labels.pop();
                  expect(_while);
                  node.test = parseParenExpression();
                  semicolon();
                  return finishNode(node, "DoWhileStatement");
                case _for:
                  next();
                  labels.push(loopLabel);
                  expect(_parenL);
                  if (tokType === _semi)
                    return parseFor(node, null);
                  if (tokType === _var) {
                    var init = startNode();
                    next();
                    parseVar(init, true);
                    finishNode(init, "VariableDeclaration");
                    if (init.declarations.length === 1 && eat(_in))
                      return parseForIn(node, init);
                    return parseFor(node, init);
                  }
                  var init = parseExpression(false, true);
                  if (eat(_in)) {
                    checkLVal(init);
                    return parseForIn(node, init);
                  }
                  return parseFor(node, init);
                case _function:
                  next();
                  return parseFunction(node, true);
                case _if:
                  next();
                  node.test = parseParenExpression();
                  node.consequent = parseStatement();
                  node.alternate = eat(_else) ? parseStatement() : null;
                  return finishNode(node, "IfStatement");
                case _return:
                  if (!inFunction && !options.allowReturnOutsideFunction)
                    raise(tokStart, "'return' outside of function");
                  next();
                  if (eat(_semi) || canInsertSemicolon())
                    node.argument = null;
                  else {
                    node.argument = parseExpression();
                    semicolon();
                  }
                  return finishNode(node, "ReturnStatement");
                case _switch:
                  next();
                  node.discriminant = parseParenExpression();
                  node.cases = [];
                  expect(_braceL);
                  labels.push(switchLabel);
                  for (var cur, sawDefault; tokType != _braceR; ) {
                    if (tokType === _case || tokType === _default) {
                      var isCase = tokType === _case;
                      if (cur)
                        finishNode(cur, "SwitchCase");
                      node.cases.push(cur = startNode());
                      cur.consequent = [];
                      next();
                      if (isCase)
                        cur.test = parseExpression();
                      else {
                        if (sawDefault)
                          raise(lastStart, "Multiple default clauses");
                        sawDefault = true;
                        cur.test = null;
                      }
                      expect(_colon);
                    } else {
                      if (!cur)
                        unexpected();
                      cur.consequent.push(parseStatement());
                    }
                  }
                  if (cur)
                    finishNode(cur, "SwitchCase");
                  next();
                  labels.pop();
                  return finishNode(node, "SwitchStatement");
                case _throw:
                  next();
                  if (newline.test(input.slice(lastEnd, tokStart)))
                    raise(lastEnd, "Illegal newline after throw");
                  node.argument = parseExpression();
                  semicolon();
                  return finishNode(node, "ThrowStatement");
                case _try:
                  next();
                  node.block = parseBlock();
                  node.handler = null;
                  if (tokType === _catch) {
                    var clause = startNode();
                    next();
                    expect(_parenL);
                    clause.param = parseIdent();
                    if (strict && isStrictBadIdWord(clause.param.name))
                      raise(clause.param.start, "Binding " + clause.param.name + " in strict mode");
                    expect(_parenR);
                    clause.guard = null;
                    clause.body = parseBlock();
                    node.handler = finishNode(clause, "CatchClause");
                  }
                  node.guardedHandlers = empty;
                  node.finalizer = eat(_finally) ? parseBlock() : null;
                  if (!node.handler && !node.finalizer)
                    raise(node.start, "Missing catch or finally clause");
                  return finishNode(node, "TryStatement");
                case _var:
                  next();
                  parseVar(node);
                  semicolon();
                  return finishNode(node, "VariableDeclaration");
                case _while:
                  next();
                  node.test = parseParenExpression();
                  labels.push(loopLabel);
                  node.body = parseStatement();
                  labels.pop();
                  return finishNode(node, "WhileStatement");
                case _with:
                  if (strict)
                    raise(tokStart, "'with' in strict mode");
                  next();
                  node.object = parseParenExpression();
                  node.body = parseStatement();
                  return finishNode(node, "WithStatement");
                case _braceL:
                  return parseBlock();
                case _semi:
                  next();
                  return finishNode(node, "EmptyStatement");
                default:
                  var maybeName = tokVal, expr = parseExpression();
                  if (starttype === _name && expr.type === "Identifier" && eat(_colon)) {
                    for (var i = 0; i < labels.length; ++i)
                      if (labels[i].name === maybeName)
                        raise(expr.start, "Label '" + maybeName + "' is already declared");
                    var kind = tokType.isLoop ? "loop" : tokType === _switch ? "switch" : null;
                    labels.push({ name: maybeName, kind });
                    node.body = parseStatement();
                    labels.pop();
                    node.label = expr;
                    return finishNode(node, "LabeledStatement");
                  } else {
                    node.expression = expr;
                    semicolon();
                    return finishNode(node, "ExpressionStatement");
                  }
              }
            }
            function parseParenExpression() {
              expect(_parenL);
              var val = parseExpression();
              expect(_parenR);
              return val;
            }
            function parseBlock(allowStrict) {
              var node = startNode(), first = true, strict2 = false, oldStrict;
              node.body = [];
              expect(_braceL);
              while (!eat(_braceR)) {
                var stmt = parseStatement();
                node.body.push(stmt);
                if (first && allowStrict && isUseStrict(stmt)) {
                  oldStrict = strict2;
                  setStrict(strict2 = true);
                }
                first = false;
              }
              if (strict2 && !oldStrict)
                setStrict(false);
              return finishNode(node, "BlockStatement");
            }
            function parseFor(node, init) {
              node.init = init;
              expect(_semi);
              node.test = tokType === _semi ? null : parseExpression();
              expect(_semi);
              node.update = tokType === _parenR ? null : parseExpression();
              expect(_parenR);
              node.body = parseStatement();
              labels.pop();
              return finishNode(node, "ForStatement");
            }
            function parseForIn(node, init) {
              node.left = init;
              node.right = parseExpression();
              expect(_parenR);
              node.body = parseStatement();
              labels.pop();
              return finishNode(node, "ForInStatement");
            }
            function parseVar(node, noIn) {
              node.declarations = [];
              node.kind = "var";
              for (; ; ) {
                var decl = startNode();
                decl.id = parseIdent();
                if (strict && isStrictBadIdWord(decl.id.name))
                  raise(decl.id.start, "Binding " + decl.id.name + " in strict mode");
                decl.init = eat(_eq) ? parseExpression(true, noIn) : null;
                node.declarations.push(finishNode(decl, "VariableDeclarator"));
                if (!eat(_comma))
                  break;
              }
              return node;
            }
            function parseExpression(noComma, noIn) {
              var expr = parseMaybeAssign(noIn);
              if (!noComma && tokType === _comma) {
                var node = startNodeFrom(expr);
                node.expressions = [expr];
                while (eat(_comma))
                  node.expressions.push(parseMaybeAssign(noIn));
                return finishNode(node, "SequenceExpression");
              }
              return expr;
            }
            function parseMaybeAssign(noIn) {
              var left = parseMaybeConditional(noIn);
              if (tokType.isAssign) {
                var node = startNodeFrom(left);
                node.operator = tokVal;
                node.left = left;
                next();
                node.right = parseMaybeAssign(noIn);
                checkLVal(left);
                return finishNode(node, "AssignmentExpression");
              }
              return left;
            }
            function parseMaybeConditional(noIn) {
              var expr = parseExprOps(noIn);
              if (eat(_question)) {
                var node = startNodeFrom(expr);
                node.test = expr;
                node.consequent = parseExpression(true);
                expect(_colon);
                node.alternate = parseExpression(true, noIn);
                return finishNode(node, "ConditionalExpression");
              }
              return expr;
            }
            function parseExprOps(noIn) {
              return parseExprOp(parseMaybeUnary(), -1, noIn);
            }
            function parseExprOp(left, minPrec, noIn) {
              var prec = tokType.binop;
              if (prec != null && (!noIn || tokType !== _in)) {
                if (prec > minPrec) {
                  var node = startNodeFrom(left);
                  node.left = left;
                  node.operator = tokVal;
                  var op = tokType;
                  next();
                  node.right = parseExprOp(parseMaybeUnary(), prec, noIn);
                  var exprNode = finishNode(node, op === _logicalOR || op === _logicalAND ? "LogicalExpression" : "BinaryExpression");
                  return parseExprOp(exprNode, minPrec, noIn);
                }
              }
              return left;
            }
            function parseMaybeUnary() {
              if (tokType.prefix) {
                var node = startNode(), update = tokType.isUpdate;
                node.operator = tokVal;
                node.prefix = true;
                tokRegexpAllowed = true;
                next();
                node.argument = parseMaybeUnary();
                if (update)
                  checkLVal(node.argument);
                else if (strict && node.operator === "delete" && node.argument.type === "Identifier")
                  raise(node.start, "Deleting local variable in strict mode");
                return finishNode(node, update ? "UpdateExpression" : "UnaryExpression");
              }
              var expr = parseExprSubscripts();
              while (tokType.postfix && !canInsertSemicolon()) {
                var node = startNodeFrom(expr);
                node.operator = tokVal;
                node.prefix = false;
                node.argument = expr;
                checkLVal(expr);
                next();
                expr = finishNode(node, "UpdateExpression");
              }
              return expr;
            }
            function parseExprSubscripts() {
              return parseSubscripts(parseExprAtom());
            }
            function parseSubscripts(base, noCalls) {
              if (eat(_dot)) {
                var node = startNodeFrom(base);
                node.object = base;
                node.property = parseIdent(true);
                node.computed = false;
                return parseSubscripts(finishNode(node, "MemberExpression"), noCalls);
              } else if (eat(_bracketL)) {
                var node = startNodeFrom(base);
                node.object = base;
                node.property = parseExpression();
                node.computed = true;
                expect(_bracketR);
                return parseSubscripts(finishNode(node, "MemberExpression"), noCalls);
              } else if (!noCalls && eat(_parenL)) {
                var node = startNodeFrom(base);
                node.callee = base;
                node.arguments = parseExprList(_parenR, false);
                return parseSubscripts(finishNode(node, "CallExpression"), noCalls);
              } else
                return base;
            }
            function parseExprAtom() {
              switch (tokType) {
                case _this:
                  var node = startNode();
                  next();
                  return finishNode(node, "ThisExpression");
                case _name:
                  return parseIdent();
                case _num:
                case _string:
                case _regexp:
                  var node = startNode();
                  node.value = tokVal;
                  node.raw = input.slice(tokStart, tokEnd);
                  next();
                  return finishNode(node, "Literal");
                case _null:
                case _true:
                case _false:
                  var node = startNode();
                  node.value = tokType.atomValue;
                  node.raw = tokType.keyword;
                  next();
                  return finishNode(node, "Literal");
                case _parenL:
                  var tokStartLoc1 = tokStartLoc, tokStart1 = tokStart;
                  next();
                  var val = parseExpression();
                  val.start = tokStart1;
                  val.end = tokEnd;
                  if (options.locations) {
                    val.loc.start = tokStartLoc1;
                    val.loc.end = tokEndLoc;
                  }
                  if (options.ranges)
                    val.range = [tokStart1, tokEnd];
                  expect(_parenR);
                  return val;
                case _bracketL:
                  var node = startNode();
                  next();
                  node.elements = parseExprList(_bracketR, true, true);
                  return finishNode(node, "ArrayExpression");
                case _braceL:
                  return parseObj();
                case _function:
                  var node = startNode();
                  next();
                  return parseFunction(node, false);
                case _new:
                  return parseNew();
                default:
                  unexpected();
              }
            }
            function parseNew() {
              var node = startNode();
              next();
              node.callee = parseSubscripts(parseExprAtom(), true);
              if (eat(_parenL))
                node.arguments = parseExprList(_parenR, false);
              else
                node.arguments = empty;
              return finishNode(node, "NewExpression");
            }
            function parseObj() {
              var node = startNode(), first = true, sawGetSet = false;
              node.properties = [];
              next();
              while (!eat(_braceR)) {
                if (!first) {
                  expect(_comma);
                  if (options.allowTrailingCommas && eat(_braceR))
                    break;
                } else
                  first = false;
                var prop = { key: parsePropertyName() }, isGetSet = false, kind;
                if (eat(_colon)) {
                  prop.value = parseExpression(true);
                  kind = prop.kind = "init";
                } else if (prop.key.type === "Identifier" && (prop.key.name === "get" || prop.key.name === "set")) {
                  isGetSet = sawGetSet = true;
                  kind = prop.kind = prop.key.name;
                  prop.key = parsePropertyName();
                  if (tokType !== _parenL)
                    unexpected();
                  prop.value = parseFunction(startNode(), false);
                } else
                  unexpected();
                if (prop.key.type === "Identifier" && (strict || sawGetSet)) {
                  for (var i = 0; i < node.properties.length; ++i) {
                    var other = node.properties[i];
                    if (other.key.name === prop.key.name) {
                      var conflict = kind == other.kind || isGetSet && other.kind === "init" || kind === "init" && (other.kind === "get" || other.kind === "set");
                      if (conflict && !strict && kind === "init" && other.kind === "init")
                        conflict = false;
                      if (conflict)
                        raise(prop.key.start, "Redefinition of property");
                    }
                  }
                }
                node.properties.push(prop);
              }
              return finishNode(node, "ObjectExpression");
            }
            function parsePropertyName() {
              if (tokType === _num || tokType === _string)
                return parseExprAtom();
              return parseIdent(true);
            }
            function parseFunction(node, isStatement) {
              if (tokType === _name)
                node.id = parseIdent();
              else if (isStatement)
                unexpected();
              else
                node.id = null;
              node.params = [];
              var first = true;
              expect(_parenL);
              while (!eat(_parenR)) {
                if (!first)
                  expect(_comma);
                else
                  first = false;
                node.params.push(parseIdent());
              }
              var oldInFunc = inFunction, oldLabels = labels;
              inFunction = true;
              labels = [];
              node.body = parseBlock(true);
              inFunction = oldInFunc;
              labels = oldLabels;
              if (strict || node.body.body.length && isUseStrict(node.body.body[0])) {
                for (var i = node.id ? -1 : 0; i < node.params.length; ++i) {
                  var id = i < 0 ? node.id : node.params[i];
                  if (isStrictReservedWord(id.name) || isStrictBadIdWord(id.name))
                    raise(id.start, "Defining '" + id.name + "' in strict mode");
                  if (i >= 0) {
                    for (var j = 0; j < i; ++j)
                      if (id.name === node.params[j].name)
                        raise(id.start, "Argument name clash in strict mode");
                  }
                }
              }
              return finishNode(node, isStatement ? "FunctionDeclaration" : "FunctionExpression");
            }
            function parseExprList(close, allowTrailingComma, allowEmpty) {
              var elts = [], first = true;
              while (!eat(close)) {
                if (!first) {
                  expect(_comma);
                  if (allowTrailingComma && options.allowTrailingCommas && eat(close))
                    break;
                } else
                  first = false;
                if (allowEmpty && tokType === _comma)
                  elts.push(null);
                else
                  elts.push(parseExpression(true));
              }
              return elts;
            }
            function parseIdent(liberal) {
              var node = startNode();
              if (liberal && options.forbidReserved == "everywhere")
                liberal = false;
              if (tokType === _name) {
                if (!liberal && (options.forbidReserved && isReservedWord5(tokVal) || strict && isStrictReservedWord(tokVal)) && input.slice(tokStart, tokEnd).indexOf("\\") == -1)
                  raise(tokStart, "The keyword '" + tokVal + "' is reserved");
                node.name = tokVal;
              } else if (liberal && tokType.keyword) {
                node.name = tokType.keyword;
              } else {
                unexpected();
              }
              tokRegexpAllowed = false;
              next();
              return finishNode(node, "Identifier");
            }
          });
        },
        "vm": (module2) => {
          module2.exports = require$$0;
        }
      };
      var __webpack_module_cache__ = {};
      function __webpack_require__(moduleId) {
        var cachedModule = __webpack_module_cache__[moduleId];
        if (cachedModule !== void 0) {
          return cachedModule.exports;
        }
        var module2 = __webpack_module_cache__[moduleId] = {
          exports: {}
        };
        __webpack_modules__[moduleId].call(module2.exports, module2, module2.exports, __webpack_require__);
        return module2.exports;
      }
      (() => {
        __webpack_require__.d = (exports2, definition) => {
          for (var key in definition) {
            if (__webpack_require__.o(definition, key) && !__webpack_require__.o(exports2, key)) {
              Object.defineProperty(exports2, key, { enumerable: true, get: definition[key] });
            }
          }
        };
      })();
      (() => {
        __webpack_require__.o = (obj, prop) => Object.prototype.hasOwnProperty.call(obj, prop);
      })();
      (() => {
        __webpack_require__.r = (exports2) => {
          if (typeof Symbol !== "undefined" && Symbol.toStringTag) {
            Object.defineProperty(exports2, Symbol.toStringTag, { value: "Module" });
          }
          Object.defineProperty(exports2, "__esModule", { value: true });
        };
      })();
      var __webpack_exports__ = {};
      (() => {
        /*!*******************************!*\
          !*** ./src/js-interpreter.js ***!
          \*******************************/
        __webpack_require__.r(__webpack_exports__);
        __webpack_require__.d(__webpack_exports__, {
          "default": () => __WEBPACK_DEFAULT_EXPORT__
        });
        const acorn = __webpack_require__("./original-repo/acorn.js");
        globalThis.acorn = acorn;
        const { Interpreter: Interpreter2 } = __webpack_require__("./original-repo/interpreter.js");
        const __WEBPACK_DEFAULT_EXPORT__ = Interpreter2;
      })();
      __webpack_exports__ = __webpack_exports__["default"];
      return __webpack_exports__;
    })();
  });
})(jsInterpreter);
const Interpreter = /* @__PURE__ */ getDefaultExportFromCjs(jsInterpreter.exports);
const processCode = (code) => {
  return code.split("\n").map((line) => {
    const trimmed = line.trim();
    if (line.includes("__awaiter"))
      return void 0;
    const isStateSetter = trimmed.startsWith("state.");
    if (!isStateSetter)
      return line;
    const [lhs, rhs] = trimmed.split("=");
    const setStr = lhs.replace("state.", "").trim();
    const setExpr = `setRootState('${setStr}', ${rhs.trim()})`;
    return `
  ${line}
  ${setExpr}
  `;
  }).filter(Boolean).join("\n");
};
const getJSONValName = (val) => val + "JSON";
const runInNonNode = ({ builder, context, event, rootState, localState, rootSetState, useCode }) => {
  const state = {
    ...rootState,
    ...localState
  };
  const properties = {
    state,
    Builder: builder,
    builder,
    context,
    event
  };
  const prependedCode = Object.keys(properties).map((key) => `var ${key} = JSON.parse(${getJSONValName(key)});`).join("\n");
  const cleanedCode = processCode(useCode);
  if (cleanedCode === "") {
    logger.warn("Skipping evaluation of empty code block.");
    return;
  }
  const transformed = `
function theFunction() {
  ${prependedCode}

  ${cleanedCode}
}
theFunction();
`;
  const setRootState = (prop, value) => {
    const newState = set(state, prop, value);
    rootSetState?.(newState);
  };
  const initFunc = function(interpreter, globalObject) {
    Object.keys(properties).forEach((key) => {
      const val = properties[key] || {};
      const jsonVal = JSON.stringify(val);
      interpreter.setProperty(globalObject, getJSONValName(key), jsonVal);
    });
    interpreter.setProperty(globalObject, "setRootState", interpreter.createNativeFunction(setRootState));
  };
  try {
    const myInterpreter = new Interpreter(transformed, initFunc);
    myInterpreter.run();
    const output = myInterpreter.pseudoToNative(myInterpreter.value);
    return output;
  } catch (e) {
    logger.warn("Custom code error in non-node runtime. SDK can only execute ES5 JavaScript.", {
      e
    });
    return;
  }
};
export {
  runInNonNode
};
